package extThopt;

import rg.corps.*;
import java.util.*; 
import javax.swing.*;

/**
 * classe de condensation sur batterie froide
 * 
 * @author Renaud GICQUEL
 */
public class ExtCombust extends ExtMixer
{
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField condenserLoad_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField sigma_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField Q_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Compr_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField Tout_value = new javax.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,P, Xinlet, Tinlet, Hinlet, flueGasFlow,fuelFlow,comburFlow;
    String flueGasProcess,fuelProcess,comburProcess,comburSubstanceName,fuelSubstanceName;
    String flueGasPoint,fuelPoint,comburPoint;
    rg.corps.Corps comburSubstance;
    rg.corps.Corps fuelSubstance;
    rg.corps.Corps flueGasSubstance;
    
    double[]inletWetGasFractmol;
    String[]inletWetGasComp;
    Vector inputWetGasComp, comburComp;
    double fractH2O,Htot,flueGasM;
    
    String outletMethanolAbsorName="";
    
    double sigma,tau;
    
    public ExtCombust (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel1.setText("lambda");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,164,20);
		JPanel1.add(sigma_value);
		sigma_value.setBounds(164,0,100,20);
		sigma_value.setText("3");
		JLabel2.setText("condenser load");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,96,164,20);
		JPanel1.add(condenserLoad_value);
		condenserLoad_value.setBounds(164,96,100,20);
		condenserLoad_value.setText("0.5");
		condenserLoad_value.setEditable(false);
		JLabel3.setText("boiler heat");
	//	JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,164,20);
	//	JPanel1.add(Q_value);
		Q_value.setBounds(164,48,100,20);
		Q_value.setText("0");
		JLabel4.setText("compression power");
	//	JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,164,20);
	//	JPanel1.add(Compr_value);
		Compr_value.setBounds(164,72,100,20);
		Compr_value.setText("0");
		JLabel5.setText("Combustion T (C)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,24,164,20);
		JPanel1.add(Tout_value);
		Tout_value.setBounds(164,24,100,20);
		Tout_value.setText("1000");
		type=getType();
		thermoCouplerTypes=new String[1];
 		thermoCouplerTypes[0]="cooler";
    }
    public void init(){
	    getMixerStructure();
        checkConsistency();
    }
    
    public String getType(){
        return "external combustion";
    }
    
    private double getSigma(){
        
        return Util.lit_d(sigma_value.getText());//lecture  l'cran de la valeur de sigma
        
    }
	public void calculateProcess(){
	
	    getMixerStructure();
        checkConsistency();
	    
	    if(isBuilt){//si le noeud externe est bien configur
	    
//	    rg.thopt.ExternalCombustion ec=new rg.thopt.ExternalCombustion();
//	    	GazIdeal combur=new GazIdeal("air",false);
//	        GazIdeal fuel=new GazIdeal("gaz_de_Montoir",false);
//	        GazIdeal flueGas=new GazIdeal("gaz_bruls",false);
	        
            double TH2O=Util.lit_d(Tout_value.getText())+273.15;
	   
	        Vector vSettings=new Vector();
	        vSettings.addElement(comburSubstance);
	        vSettings.addElement(fuelSubstance);
	        vSettings.addElement(new Double(comburFlow));//oxidizer flow rate
	        vSettings.addElement(new Double(fuelFlow));//fuel flow rate
	        vSettings.addElement(new Double(3.));//lambda
	        vSettings.addElement(new Double(TH2O));//Tfluegas
	        vSettings.addElement(new Double(0.05));//dissociation rate
	        vSettings.addElement("true");//dissociation boolean
	        vSettings.addElement(new Double(1273.15));//Tfigeage
	        vSettings.addElement(new Double(0.));//a
	        vSettings.addElement(new Double(0.));//hf0carb
	        vSettings.addElement("false");//comb CHa
	        vSettings.addElement(new Double(0.));//hc
	        vSettings.addElement(new Double(0.));//uc
	        vSettings.addElement(new Double(0.));//Mc
	        vSettings.addElement(new Double(0.));//heat load
	        vSettings.addElement("true");//open system
	        vSettings.addElement("false");//IcalcDirect //si true on calcule Tad  partir de lambda
	        vSettings.addElement(flueGasSubstance);
	        vSettings.addElement(new Double(300));//T amont
	        vSettings.addElement(new Double(0));//H amont
	        vSettings.addElement(new Double(1.));//rendement chambre
	        
	        calcExternalCombustion(vSettings);
	        
	        Vector results=getExternalCombustionResults();
            Double y=(Double)results.elementAt(2);
            double lambda=y.doubleValue();
	        System.out.println("lambda : "+lambda);
	        sigma_value.setText(Util.aff_d(lambda,5));
        /*    sigma=getSigma();//mthode de calcul de sigma

	        comburComp=inputWetGasComp;

            //recalcul des fractions molaires pour tenir compte de l'extraction de H2O
	        for(int i=0;i<inletWetGasFractmol.length;i++){//mise  jour des fractions molaire de sortie
	            double x_out=inletWetGasFractmol[i]/(1-sigma*fractH2O);
	            Util.updateMolarComp(comburComp,inletWetGasComp[i], x_out);
	        }
            double xH2O_out=(1-sigma)*fractH2O/(1-sigma*fractH2O);//fraction molaire de sortie en H2O
	        Util.updateMolarComp(comburComp,"H2O", xH2O_out);
	        
            comburSubstance.updateGasComposition(comburComp);

            double wetSynGasMolFlow=flueGasFlow/flueGasM;
            double H2OMassFlowTotal=wetSynGasMolFlow*fractH2O*18.01528;
            double H2Oflow=H2OMassFlowTotal*sigma;
            
            double L0_eau=2501.593;  
            Object obj=Corps.createSubstance("H2O");//instanciation du corps, encapsul dans un Object
            Corps lH2O=(Corps)obj;//transtypage de l'Object
            lH2O.CalcPropCorps(TH2O,20, 0);
            //tout se passe comme si l'on refroidissait le gaz H2O jusqu' 30 C, et qu'on le condensait
            double Heau=(Hsubst-L0_eau)*H2Oflow;
            
            comburSubstance.CalcPropCorps(TH2O,20, 0);
            double Hcombur=Hsubst*(wetSynGasMolFlow-H2Oflow);
            
            //charge du condenseur
            double condLoad=Htot-Heau-Hcombur;
	        
            
            //affichages  l'cran
            Compr_value.setText(Util.aff_d(0,2));
            Q_value.setText(Util.aff_d(0,2));
            condenserLoad_value.setText(Util.aff_d(condLoad,2));
            sigma_value.setText(Util.aff_d(sigma,2));

            //mise  jour des thermocoupleurs, comme pinchFluid, DTmin=10
	        updateThermoCoupler("cooler", Tinlet-10, TH2O+10, condLoad, flueGasFlow,true,10);
	   
	        //mise  jour du noeud en utilisant les mthodes gnriques
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
	        setupVector(fuelProcess, fuelPoint, 0, fuelFlow, TH2O, Pamont, 1);
	        setupVector(comburProcess, comburPoint, 1, flueGasFlow-fuelFlow, TH2O, Pamont, 0);
	        setupVector(flueGasProcess, flueGasPoint, 2, flueGasFlow, Tinlet, Pamont, Xinlet);
            updateMixer(vTransfo,vPoints,Tinlet,Hinlet*flueGasFlow);

	        me.updateProcess(setEnergyTypes(flueGasProcess,0,0,0));
	        */
        }

	}

    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        fuelProcess="";
        comburProcess="";
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(me, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String aval=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(aval);//direct parsing of point property vector
                getSubstProperties(nomCorps);
                String nom=nomCorps;
                if(typeSubst==1){//le corps de sortie est de l'eau
	            }
	            else if(typeSubst==4){//le corps d'entre est un gaz compos
                    Vector vComp=lecorps.getGasComposition();
                    System.out.println(" nbElements "+vComp.elementAt(0));

	                if(Util.contains(vComp,"O2")){
	                    comburProcess=nomBranche[j];
	                    comburPoint=aval;
                        args=new String[2];
                        args[0]="process";//type of the element (see method getProperties(String[] args))
                        args[1]=comburProcess;//name of the process (see method getProperties(String[] args))
                        Vector vProp=proj.getProperties(args);
                        aval=(String)vProp.elementAt(1);//gets the upstream point name
                        getPointProperties(aval);//direct parsing of point property vector
	                    comburSubstance=lecorps;
	                    comburSubstanceName=nomCorps;
	                    Double f=(Double)vProp.elementAt(3);
	                    comburFlow=f.doubleValue();
	                    
	                }
	                else{
	                    fuelProcess=nomBranche[j];
	                    fuelPoint=aval;
                        args=new String[2];
                        args[0]="process";//type of the element (see method getProperties(String[] args))
                        args[1]=fuelProcess;//name of the process (see method getProperties(String[] args))
                        Vector vProp=proj.getProperties(args);
                        aval=(String)vProp.elementAt(1);//gets the upstream point name
                        getPointProperties(aval);//direct parsing of point property vector
	                    fuelSubstance=lecorps;
	                    fuelSubstanceName=nomCorps;
	                    Double f=(Double)vProp.elementAt(3);
	                    fuelFlow=f.doubleValue();
	                }
	            
	            
	            }
	            else{//le corps de sortie n'est ni de l'eau ni un gaz compos
	                String msg = "Error: the outlet substance is not of the right type";
	                JOptionPane.showMessageDialog(me, msg);  
	            }
	        }
	        if((fuelProcess.equals(""))||(comburProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(me, msg);  
	            isBuilt=false;
	        }
        }
        flueGasProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=flueGasProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    Double f=(Double)vPropMain.elementAt(3);
	    flueGasFlow=f.doubleValue();
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
        Vector vComp=lecorps.getGasComposition();
        flueGasSubstance=lecorps;
	    flueGasPoint=aval;
	    Tinlet=Tpoint;
	    Hinlet=Hpoint;
        Pamont=Ppoint;
        
        
        
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        inputWetGasComp=lecorps.getGasComposition();//composition du gaz  traiter
        fractH2O=Util.molarComp(inputWetGasComp,"H2O");//fraction molaire de H2O
        flueGasM=Msubst;//masse molaire du gaz  traiter
        Htot=Hsubst*flueGasFlow;
//            System.out.println("Htot : "+Htot);
        //chargement du tableau des fractions molaires du gaz  traiter
        Integer i=(Integer)inputWetGasComp.elementAt(0);
	    int nComp=i.intValue(); 
        inletWetGasComp= new String[nComp];
        Double[]fracMol= new Double[nComp];
        inletWetGasFractmol= new double[nComp];
	    inletWetGasComp=(String[])inputWetGasComp.elementAt(1);
	    fracMol=(Double[])inputWetGasComp.elementAt(2);
        for(int j=0;j<nComp;j++){
            inletWetGasFractmol[j]= fracMol[j].doubleValue();
        }
        
	    
	    
/*
        //Check the substance at inlet
	    if(!((typeSubst==4)&&(Util.contains(vComp,"H2O")))){
	        String msg = "Error on main process substance,which is not a gas containing H2O";
	        JOptionPane.showMessageDialog(me, msg);  
	        isBuilt=false;
	    }
        */
    }

	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "condenserLoad_value");
        double condenserLoad=0;
        if(valeur!=null)condenserLoad=Util.lit_d(valeur);
	    condenserLoad_value.setText(Util.aff_d(condenserLoad,3));
		double Tout=Util.lit_d(Util.extr_value(ligne_data, "Tout_value"));
	    Tout_value.setText(Util.aff_d(Tout,2));
		double Q=Util.lit_d(Util.extr_value(ligne_data, "Q_value"));
	    Q_value.setText(Util.aff_d(Q,2));
		double current=Util.lit_d(Util.extr_value(ligne_data, "Compr_value"));
	    Compr_value.setText(Util.aff_d(current,2));
	    valeur=Util.extr_value(ligne_data, "sigma_value");
        if(valeur!=null)sigma=Util.lit_d(valeur);
	    sigma_value.setText(Util.aff_d(sigma,3));
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"sigma_value="+sigma_value.getText()+tab
	    +"condenserLoad_value="+condenserLoad_value.getText()+tab
	    +"Tout_value="+Tout_value.getText()+tab
	    +"Q_value="+Q_value.getText()+tab
	    +"Compr_value="+Compr_value.getText()+tab
	    ;
        return h;
    }
}