/*
Copyright Renaud GICQUEL 2009  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;

/**
 * Classe de dimensionnement technologique d'un turbocompresseur avec cartographie d'tage
 * Technological design class for mapped turbocompressors
 */

public class MultiStageMappedTurboCompr extends TechnoTurboCompr implements Inversable
{
	double alphaXsurge, alphaYsurge, alphaXlim, alphaYlim;	
	double betaXsurge, betaYsurge, betaXlim, betaYlim;	
	double gammaXsurge, gammaYsurge, gammaXlim, gammaYlim;	
	double alphaA, alphaB, alphaC, alphaD;	
	double betaA, betaB, betaC, betaD;	
	double gammaA, gammaB, gammaC, gammaD;	
	double alphaA1, alphaA2, alphaA3, alphaA4;	
	double betaA1, betaA2, betaA3, betaA4;	
	double gammaA1, gammaA2, gammaA3, gammaA4;	
	
	double a,b,c,d,a1,a2,a3,a4,xSurge,ySurge,xLim,yLim,RpAdim,RpInit,Nmin,Nmax,Nref;
	double mRef=1,RpRef=1,etaRef=1,racT0,T0,P0,N0;
	double mDesign=1,RpDesign=1,etaDesign=1;
	

	public MultiStageMappedTurboCompr(){
	}

	public MultiStageMappedTurboCompr(Projet proj, String compressorName, PointThopt amont, PointThopt aval){
		super(proj, compressorName, amont, aval);
	    this.compressorName=componentName;
	    tcf=new TurboComprMapDataFrame(this);
//	    tcf.show();
	    tcf.loadSettings();
	    setupPanel();
	}
	public MultiStageMappedTurboCompr(Projet proj, String compressorName){
		super(proj, compressorName);
	    this.compressorName=componentName;
	    setupPanel();
	}
    void setupPanel(){
        super.setupPanel();
		JLabeImg.setText("Compressor maps");
		JPanel1.add(JLabeImg);
		JLabeImg.setBounds(3,50,228,36);
		JLabeImg.setBounds(372,87,250,300);
		JLabel1.setText("Compressor data");
		JLabel1.setBounds(3,80,228,36);
		JLabel1.setBounds(550,0,228,36);

		JPanel1.remove(psiCoeff_value);
		JPanel1.remove(JLabel9);
		JPanel1.remove(phiPsiMax_value);
		JPanel1.remove(JLabel3);
		JPanel1.remove(psiMax_value);
		JPanel1.remove(JLabel2);
		JPanel1.remove(D_value);
		JLabel5.setText("eta design");
		//etaMax_value.setText("0.85");
		JLabel6.setText("Rp design");
		//etaCoeff_value.setText("-10");
		JLabel4.setText("m design");
		//phiEtaMax_value.setText("0.3");
		JLabel7.setText("relative rot. speed");
		JLabel7.setBounds(new Rectangle(4, 87, 108, 24));
		Kc_value.setBounds(148,87,120,24);
		Kc_value.setEditable(false);
		Kc_value.setText("1");
		JLabel14.setText("relative isentr. eff.");
		JLabel14.setBounds(4,117,144,24);
		risentr_value.setBounds(148,117,120,24);
		JLabel15.setText("relative pressure ratio");
		JLabel15.setBounds(new Rectangle(4, 147, 132, 24));
		m_value.setBounds(new Rectangle(148, 147, 120, 24));
		JLabel12.setText("relative flow rate");
		JLabel12.setBounds(4,177,144,24);
		mc_value.setBounds(new Rectangle(148, 177, 120, 24));
		SymMouse aSymMouse = new SymMouse();
		JLabeImg.addMouseListener(aSymMouse);
		JLabel1.addMouseListener(aSymMouse);
		mc_value.setEditable(false);
		m_value.setEditable(false);
		risentr_value.setEditable(false);
        N=1;
        JPanel1.add(JLabel18);
        JPanel1.add(stageNumber_value);
		JLabel18.setText("stage number");
		JLabel18.setBounds(new Rectangle(4, 205, 144, 24));
		stageNumber_value.setText("1");
		JLabel18.setBounds(new Rectangle(4, 330, 144, 24));
		stageNumber_value.setBounds(new Rectangle(148, 330, 120, 24));
	}

    public String getType(){
        return "MultiStageMappedTurboCompr";
    }
	
    public String getClassName(){
        return "MultiStageMappedTurboCompr";
    }
    
    public String getClassCode(){
        return "Compression";
    }

	//{{DECLARE_CONTROLS
	//}}
	
	/*
	A faire :
	- dfinir une carto lmentaire valables pour le cas axial
	*/

public void initSettings(){
	alphaXsurge=Util.lit_d(tcf.alphaXsurge_value.getText());
	alphaYsurge=Util.lit_d(tcf.alphaYsurge_value.getText());
	alphaXlim=Util.lit_d(tcf.alphaXlim_value.getText());
	alphaYlim=Util.lit_d(tcf.alphaYlim_value.getText());

	betaXsurge=Util.lit_d(tcf.betaXsurge_value.getText());
	betaYsurge=Util.lit_d(tcf.betaYsurge_value.getText());
	betaXlim=Util.lit_d(tcf.betaXlim_value.getText());
	betaYlim=Util.lit_d(tcf.betaYlim_value.getText());

	gammaXsurge=Util.lit_d(tcf.gammaXsurge_value.getText());
	gammaYsurge=Util.lit_d(tcf.gammaYsurge_value.getText());
	gammaXlim=Util.lit_d(tcf.gammaXlim_value.getText());
	gammaYlim=Util.lit_d(tcf.gammaYlim_value.getText());

	alphaA=Util.lit_d(tcf.alphaA_value.getText());
	alphaB=Util.lit_d(tcf.alphaB_value.getText());
	alphaC=Util.lit_d(tcf.alphaC_value.getText());
	alphaD=Util.lit_d(tcf.alphaD_value.getText());

	betaA=Util.lit_d(tcf.betaA_value.getText());
	betaB=Util.lit_d(tcf.betaB_value.getText());
	betaC=Util.lit_d(tcf.betaC_value.getText());
	betaD=Util.lit_d(tcf.betaD_value.getText());
	
	gammaA=Util.lit_d(tcf.gammaA_value.getText());
	gammaB=Util.lit_d(tcf.gammaB_value.getText());
	gammaC=Util.lit_d(tcf.gammaC_value.getText());
	gammaD=Util.lit_d(tcf.gammaD_value.getText());
	
	alphaA1=Util.lit_d(tcf.alphaA1_value.getText());
	alphaA2=Util.lit_d(tcf.alphaA2_value.getText());
	alphaA3=Util.lit_d(tcf.alphaA3_value.getText());
	alphaA4=Util.lit_d(tcf.alphaA4_value.getText());

	betaA1=Util.lit_d(tcf.betaA1_value.getText());
	betaA2=Util.lit_d(tcf.betaA2_value.getText());
	betaA3=Util.lit_d(tcf.betaA3_value.getText());
	betaA4=Util.lit_d(tcf.betaA4_value.getText());

	gammaA1=Util.lit_d(tcf.gammaA1_value.getText());
	gammaA2=Util.lit_d(tcf.gammaA2_value.getText());
	gammaA3=Util.lit_d(tcf.gammaA3_value.getText());
	gammaA4=Util.lit_d(tcf.gammaA4_value.getText());

	//conditions de rfrence
	mRef=Util.lit_d(tcf.mRef_value.getText());
	RpRef=Util.lit_d(tcf.RpRef_value.getText());
	etaRef=Util.lit_d(tcf.etaRef_value.getText());
	T0=Util.lit_d(tcf.T0_value.getText());
	P0=Util.lit_d(tcf.P0_value.getText());
	Nmin=Util.lit_d(tcf.Nmin_value.getText());
	Nmax=Util.lit_d(tcf.Nmax_value.getText());
	Nref=Util.lit_d(tcf.Nref_value.getText());
	racT0=Math.pow(T0,0.5);//racine de T0 pour correction vitesse et dbit corrigs
}

    public void setNparameters(){
        a=getA(N);
        b=getB(N);
        c=getC(N);
        d=getD(N);
        a1=getA1(N);
        a2=getA2(N);
        a3=getA3(N);
        a4=getA4(N);
        xSurge=getXsurge(N);
        ySurge=getYsurge(N);
        xLim=getXlim(N);
        yLim=getYlim(N);
    }
    public double getXsurge(double N){
        return alphaXsurge+betaXsurge*N+gammaXsurge*N*N;
    }
    public double getYsurge(double N){
        return alphaYsurge+betaYsurge*N+gammaYsurge*N*N;
    }
    public double getXlim(double N){
        return alphaXlim+betaXlim*N+gammaXlim*N*N;
    }
    public double getYlim(double N){
        return alphaYlim+betaYlim*N+gammaYlim*N*N;
    }
    public double getA(double N){
        return alphaA+betaA*N+gammaA*N*N;
    }
    public double getB(double N){
        return alphaB+betaB*N+gammaB*N*N;
    }
    public double getC(double N){
        return alphaC+betaC*N+gammaC*N*N;
    }
    public double getD(double N){
        return alphaD+betaD*N+gammaD*N*N;
    }
    public double getA1(double N){
        return alphaA1+betaA1*N+gammaA1*N*N;
    }
    public double getA2(double N){
        return alphaA2+betaA2*N+gammaA2*N*N;
    }
    public double getA3(double N){
        return alphaA3+betaA3*N+gammaA3*N*N;
    }
    public double getA4(double N){
        return alphaA4+betaA4*N+gammaA4*N*N;
    }
	
	public void setDesignValues(){
	    mDesign=Util.lit_d(phiEtaMax_value.getText());
	    RpDesign=Util.lit_d(etaCoeff_value.getText());
	    etaDesign=Util.lit_d(etaMax_value.getText());
	}

	public void setN(double N_0){
	    N0=N_0;
	    updateN();
	}

	public void updateN(){
	    double racT=Math.pow(amont.T,0.5);//racine de T pour correction vitesse corrige
	    N=N0*racT0/racT;
	    Kc_value.setText(Util.aff_d(N,5));
	}

    
	/**
	 * gets the reduced speed corresponding to Rp and massFlow
	 */
	double getNfromRpAndFlow(double Rp, double massFlow){
	    double N=N0;
	    RpInit=Rp;
	    N=Util.dicho_T(this,0,massFlow, "getN_Rp_m",Nmin, Nmax,0.0001);
	    if(N==0){
 	        String message="Watch out! The N value is not within the interval limits\nThe turbocompressor map may be invalid"; 
	        JOptionPane.showMessageDialog(new JFrame(),message);
	    }
	    return N;
	}
	public double f_dicho(double X, double T,String fonc){
                    
        if (fonc.equals("getN_Rp_m"))return getN_Rp_m(X, T);
        return 0;
    }
	double getN_Rp_m(double N, double massFlow){
	    double mn=getRelativeFlow(massFlow)/getXsurge(N);
	    double RpAdim=Math.pow(RpInit,1./stageNumber)/getYsurge(N)/RpRef;
	    double res=1;
	    if(tcf.functionRp.equals("cubic"))res=RpAdim-(getA(N)+getB(N)*mn+getC(N)*mn*mn+getD(N)*mn*mn*mn);
        else if(tcf.functionRp.equals("sinus"))res=RpAdim-(getA(N)*Math.sin(getB(N)*mn+getC(N))+getD(N)*mn);
	    
	    return res;
	}
	
	/**
	 * cheks if the compressor reduced speed is within the map limits
	 */
	void checkMapValidity(){
        if(N<Nmin){
	        String message="The compressor reduced speed is lower than the minimum  \nThe turbocompressor map may be invalid";  
	        JOptionPane.showMessageDialog(new JFrame(),message);
        }
        if(N>Nmax){
	        String message="The compressor reduced speed is greater than the maximum  \nThe turbocompressor map may be invalid";  
	        JOptionPane.showMessageDialog(new JFrame(),message);
        }
    }
    	
	double getRisentr(){
	    return getRisentr(getRelativeFlow(getFlow()));
	}
	
	double getRisentr(double m){
        double mn=m/xSurge;
	    double eta=1;
	    if(tcf.functionEta.equals("sinus"))
	        eta=(a1*Math.sin(a2*mn+a3)+a4*mn)*etaRef;
	    else if(tcf.functionEta.equals("cubic"))
	        eta=(a1+a2*mn+a3*mn*mn+a4*mn*mn*mn)*etaRef;
	    
        if((stageNumber>1)&&(!tcf.modeEta.equals("polytropic"))){//cas isentropique
        // non ncessaire si la cartographie est celle d'une machine complte, car eta est dj gal au rendement isentropique
            double k=getPolytropicCoefficient();
            double beta_k=(k-1.)/k;
            double beta=beta_k*eta;
            if(k<=1){
                double gamma=getGamma();
                beta=(gamma-1.)/gamma;
                beta_k=beta/eta;
            }
            double Rp=getPressureRatio(getFlow());
	        double eta_polytr=beta_k*Math.log(Rp)/Math.log(1+(Math.pow(Rp,beta_k)-1.)/eta);
	        beta=beta_k*eta_polytr;
        }
        else{//cas polytropique
            double k=getPolytropicCoefficient();
            double beta_k=(k-1.)/k;
            double beta=beta_k*eta;
            if(k<=1){
                double gamma=getGamma();
                beta=(gamma-1.)/gamma;
                beta_k=beta/eta;
            }
            double Rp=getPressureRatio(getFlow());
            eta=(Math.pow(Rp,beta)-1.) /(Math.pow(Rp,beta_k)-1.);
        }
	    
	    if(eta<0.25)eta=0.25;
	    risentr_value.setText(Util.aff_d(eta/etaRef,4));
	    return eta;
	}	
	
	double getReducedFlow(double massFlowRate){
	    double racT=Math.pow(amont.T,0.5);//racine de T pour correction dbit corrig
        double reducedFlow=massFlowRate*racT/amont.P;
	    return reducedFlow;
    }

	double getDesignRisentr(){//rendement isentropique initial de la transfo compression
        String[] args=new String[2];
        args[0]="process";
        args[1]=componentName;
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(11);
        return f.doubleValue();
	}

	public void makeDesign(){//cale le point nominal de la cartographie sur les conditions de la compression
	    //dans un deuxime temps, on pourra en dduire les dimensions
	    
	    initSettings();//relit les paramtres des cartographies
	    setNparameters();//calcule les paramtres qui dpendent de N
	    updateN();
	    mDesign=getFlow();
        setStageNumber();
	    etaDesign=getDesignRisentr();
	    RpDesign=aval.P/amont.P;
	    m_value.setText(Util.aff_d(RpDesign/RpRef,5));
	    risentr_value.setText(Util.aff_d(etaDesign/etaRef,4));

	    phiEtaMax_value.setText(Util.aff_d(mDesign,5));
	    etaCoeff_value.setText(Util.aff_d(RpDesign,5));
	    etaMax_value.setText(Util.aff_d(etaDesign,5));
	}

	double getRelativeFlow(double massFlowRate){
	    double racT=Math.pow(amont.T,0.5);//racine de T pour correction dbit corrig
        double relativeFlow=massFlowRate/mRef*racT/racT0*P0/amont.P;
	    mc_value.setText(Util.aff_d(relativeFlow,4));
	    return relativeFlow;
    }
    	
    public double getPressureRatio(double massFlowRate){
        double mn=getRelativeFlow(massFlowRate)/xSurge;
        double z=0;
        if(tcf.functionRp.equals("cubic"))z=(a+b*mn+c*mn*mn+d*mn*mn*mn)*ySurge*RpRef;
        else if(tcf.functionRp.equals("sinus"))z=(a*Math.sin(b*mn+c)+d*mn)*ySurge*RpRef;
        z=Math.pow(z,stageNumber);
	    m_value.setText(Util.aff_d(z/RpDesign,5));
        return z;
    }

	/**
	 * gets the number of stages corresponding to the reduced speed and massFlow
	 */
	int getStageNumber(double N, double massFlow){
	    
	/*    	    for(int k=0;k<6;k++){
	        N=0.4+k*0.15;
	        for(int j=0;j<6;j++){
	            double mred=N+j*0.1;
	            double xs=getXsurge(N);
	            double mn=mred/xs;
	            double res=1;
	            if(tcf.functionRp.equals("cubic"))res=getYsurge(N)*(getA(N)+getB(N)*mn+getC(N)*mn*mn+getD(N)*mn*mn*mn);
                else if(tcf.functionRp.equals("sinus"))res=getYsurge(N)*(getA(N)*Math.sin(getB(N)*mn+getC(N))+getD(N)*mn);
        res=Math.pow(res,stageNumber);
	            double  eta=0;
	            if(tcf.functionEta.equals("sinus"))
	                eta=(getA1(N)*Math.sin(getA2(N)*mn+getA3(N))+getA4(N)*mn)*etaRef;
	            else if(tcf.functionEta.equals("cubic"))
	                eta=(getA1(N)+getA2(N)*mn+getA3(N)*mn*mn+getA4(N)*mn*mn*mn)*etaRef;
	            
	            
	            System.out.println(N+"\t"+mred+"\t"+mn+"\t"+res+"\t"+eta);
	        }
	    }
	    
	    */

	    double Rp=aval.P/amont.P;
	    double[] res=new double[100];
	    double res1=1;
	    double mn=getRelativeFlow(massFlow);
	    double ys=getYsurge(N);
	    double ms=getXsurge(N);
	    mn=mn/ms;
	    if(tcf.functionRp.equals("cubic"))
	        res1=(getA(N)+getB(N)*mn+getC(N)*mn*mn+getD(N)*mn*mn*mn)*RpRef;
        else if(tcf.functionRp.equals("sinus"))
            res1=(getA(N)*Math.sin(getB(N)*mn+getC(N))+getD(N)*mn)*RpRef;
	    for(int k=1;k<100;k++){//on recherche la racine nime de Rp pour laquelle la cartographie est adapte
            double rp=Math.pow(Rp,1./k);
            res[k]=(rp-res1*ys)*(rp-res1*ys);
        }
        double min=res[1];
        int j=1;
	    for(int k=2;k<100;k++){
            if(res[k]<min){
                min=res[k];
                j=k;
            }
        }
	    return j;
	}
	
	
	void setStageNumber(){
        stageNumber=Util.lit_i(stageNumber_value.getText());
	}

	void setStageNumber(int j){
        stageNumber=j;
        stageNumber_value.setText(Util.aff_i(j));
	}
    
	public void readCompParameters(String ligne_data){
        D_value.setText(Util.extr_value(ligne_data, "D_value"));
        String valeur;
        valeur=Util.extr_value(ligne_data, "Kc_value");
        if(valeur!=null)Kc_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "psiMax_value");
        if(valeur!=null)psiMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "psiCoeff_value");
        if(valeur!=null)psiCoeff_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "phiPsiMax_value");
        if(valeur!=null)phiPsiMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "etaCoeff_value");
        if(valeur!=null)etaCoeff_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "etaMax_value");
        if(valeur!=null)etaMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "phiEtaMax_value");
        if(valeur!=null)phiEtaMax_value.setText(valeur);
	}


	/**
	 * saves project file specific technoDesign data
	 */
    public String saveCompParameters(){
	    String h="D_value="+D_value.getText()+tab
	    +"Kc_value="+Kc_value.getText()+tab
	    +"psiMax_value="+psiMax_value.getText()+tab
	    +"psiCoeff_value="+psiCoeff_value.getText()+tab
	    +"phiPsiMax_value="+phiPsiMax_value.getText()+tab
	    +"etaCoeff_value="+etaCoeff_value.getText()+tab
	    +"etaMax_value="+etaMax_value.getText()+tab
	    +"phiEtaMax_value="+phiEtaMax_value.getText()+tab
	    +"\n";
        return h;
    }
    
	class SymMouse extends java.awt.event.MouseAdapter
	{

		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
				MappedTurboCompr_mousePressed(event);
		}
	}
    public void setImageFile(String fileName){
        if(map==null)map=new MapImage("Compressor maps",this, im);
//        map.show();
        map.setImageFile(fileName);
    }
    public String getMapImage(){
        if(map==null)return "";
        else return map.imageFile;
    }
    
    public void setDataFile(String fileName){
        tcf.setDataFile(fileName);
    }
    public String getDataFile(){
        return tcf.dataFileName;
    }
    
	
    void MappedTurboCompr_mousePressed(java.awt.event.MouseEvent event)
    {
		    Object object = event.getSource();
	    int nb_click=event.getClickCount();
	    if(nb_click>=2){
	        if (object == JLabeImg){
	                if(map==null)map=new MapImage("Compressor maps",this, im);
	                map.show();
	        }
	        if (object == JLabel1){
	                if(tcf==null)tcf=new TurboComprMapDataFrame(this);
	                tcf.show();
	        }
        }
    }
    
}
 