/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import java.util.*;

public class ExtHorCondConfig extends FlowConfig 
{
    public ExtHorCondConfig (){
    }

    public ExtHorCondConfig (TechnoExch te){
        super(te);
        NuCorrel="B1540 T/I";
		te.JPanel1.add(te.display_value);
		te.JPanel1.add(te.displayLabel);
		te.displayLabel.setText("pressure factor");
		te.display_value.setText("1");
//		te.JLabel13.setText("L Nt**0.25");
        
    }
        
    public String getCode(){
        return "cond_ext_hor";
    }
    
	public String getClassDescription(){
	    return "Levy correlation for condensation outside horizontal tubes (B1540 T/I)";
	}
    
	public double calcNu(double P){
//	    double Nu;
//	    double P=comp.amont.getP();
	    if(te.diph){//calcul de Ulv
	        Nu=calcNu(te.aval.X,te.amont.X);//nombre de Nsselt
//	        Nu=Nu*(0.78738+6187.89/te.getG()/te.getG());//Correction de Bivens

	        //prise en compte du taux de vide pour le calcul de la charge en frigorigne
	        double Tsat=te.corps.lecorps.getSatTemperature(P,0);
	        P=te.corps.lecorps.getSatPressure(Tsat, 0);
	        te.corps.lecorps.CalcPropCorps(Tsat, P, 0);
	        te.corps.getSubstProperties();
	        double Vl=te.corps.V;
	        Tsat=te.corps.lecorps.getSatTemperature(P,1);
	        P=te.corps.lecorps.getSatPressure(Tsat, 1);
	        te.corps.lecorps.CalcPropCorps(Tsat, P, 1);
	        te.corps.getSubstProperties();
	        double Vv=te.corps.V;
	        
	        calcMeanDensity(Vl, Vv, 1, 0);

	    }
	    else Nu=calcNuTube();
	    
	    return Nu;
	}
	
	
    private double calcNu(double xs, double xe){//nombre de Nsselt pour un tube
        //xs est le titre de sortie
        //xe est le titre d'entre
        boolean ensic=false;
        if(ensic){//non retenue car non rfrence et donne des valeurs trs faibles
            te.corps.lecorps.CalcPropCorps(te.aval.T-0.1,te.aval.P,0.);
	        te.corps.getSubstProperties();
	        double rho=1./te.corps.V;
	        double y=rho*rho*9.81/te.mu/te.mu;
	        double z = te.getFlow()/Util.lit_d(te.L_value.getText())*4/te.mu;
	        Nu=1.51*Util.lit_d(te.Dh_value.getText())*Math.pow(y,0.33333)/Math.pow(z,0.33333);
	    }
	    else{//Corrlation B1540 T/I p.3 section 1.2.2
            te.corps.lecorps.CalcPropCorps(te.aval.T-0.1,te.aval.P,0.);
	        te.corps.getSubstProperties();
	        double rho=1./te.corps.V;
	        
	        te.initLambdaMu(te.aval.T, te.aval.P, 0);
	        double y=te.lambda*te.lambda*te.lambda*rho*rho*9.81*te.amont.H;
	        //on prend la demi-somme des tempratures des deux fluides
	        double Tcooling=(te.tHx.techf.amont.T+te.tHx.techf.aval.T)/2.;
//	        double Tcooling=te.tHx.techf.aval.T;(essai effectu pour Cybiam, mais non gnrique)
	        //pour bien faire, il faudrait barycentrer compte tenu des coefficients d'change de chaque fluide
	        double Twall=(Tcooling+te.aval.T)/2.;
	        double deltaT=te.aval.T-Twall;
	        y=y/te.mu/Util.lit_d(te.tHx.techf.Dh_value.getText())/deltaT;
	        Nu=3.022*Util.lit_d(te.Dh_value.getText())/te.lambda*Math.pow(y,0.25);
	    }
        return Nu;
    }
	
/*	
	public double get_f(){
	    return 1.;
	}
	*/
	public double calcDP(){
	    te.initLambdaMu(te.amont.T, te.amont.P, te.amont.X);
	    return calcDPdiff();
	}
	
	public double calcDPdiff(){//modRG 2009 j'ai directement copi ceci de CondConfig. A vrifier
        double Tsat=te.corps.lecorps.getSatTemperature(te.aval.P, 0);//pression de condensation
	    te.corps.lecorps.CalcPropCorps(Tsat-0.1,te.aval.P,0);
	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
	    double dPl=calcDP(v);
	    double z=(1+Math.abs(te.aval.X-te.amont.X)*(te.ro_l/te.ro_v-1));
	    double y=(1+Math.abs(te.aval.X-te.amont.X)*(te.mu_l/te.mu_v-1));
	    y=Math.pow(y, -0.2);
 //       System.out.println(te.exchangeName+"  z "+z+"  te.ro_l "+te.ro_l+"  te.ro_v "+te.ro_v);	        
 //       System.out.println(te.exchangeName+"  y "+y+"  te.mu_l "+te.mu_l+"  te.mu_v "+te.mu_v);	        
	    double dPlv=z*y*dPl;
	    double dPv=calcDP(te.amont.V);
 //       System.out.println("dPl "+dPl+"  dPv "+dPv+"  dPlv "+dPlv);	        	    
	    dPl=calcDP(te.aval.V);
 //       System.out.println("dPl "+dPl+"  dPv "+dPv+"  dPlv "+dPlv);	        

	    double zz=0;//deux cas selon qu'il s'agit d'un changeur ou d'un thermocoupleur
	    if(te.tHx!=null)zz=te.tHx.Al/te.tHx.A*dPl+te.tHx.Alv/te.tHx.A*dPlv+te.tHx.Av/te.tHx.A*dPv;
	    if(te.tTc!=null)zz=te.tTc.Al/te.tTc.A*dPl+te.tTc.Alv/te.tTc.A*dPlv+te.tTc.Av/te.tTc.A*dPv;
	    
	    return zz;
	}

	public double getPressFactor(){
	    return Util.lit_d(te.display_value.getText());
    }
	public void setPressFactor(double fact){
	    te.display_value.setText(Util.aff_d(fact));
    }
	
	
	/**
	 * reads specific technoDesign parameters
	 */
	public void readCaract(String ligne_data){
	    super.readCaract(ligne_data);
        String valeur;
        valeur=Util.extr_value2(ligne_data, "pressure_factor");
        if(valeur!=null){
            double value=Util.lit_d(valeur);
            te.display_value.setText(valeur);
        }
	}

	/**
	 * saves specific technoDesign parameters
	 */
    public String saveCaract(){
	    String h=super.saveCaract();
        h=h+"pressure_factor="+te.display_value.getText()+":"
        ;
        return h;
    }
	
	

}