package extThopt;

import java.util.*; 
import java.io.*;
import javax.swing.*;

/**
* This class is an example of an external mixture for Thermoptim.
*<p>This class may be modified under the CeCILL copyright

Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
 * 
 * @author Renaud GICQUEL
*/
public abstract class ExtPropServer extends extThopt.ExtSubstance implements ExternalMixture, Inversable
{
    
    double x, massMol;
    Vector vMixtures;
    String selectedSyst,selectedFile;
    public double fract_mol[];
    public double fract_mass[];
    StringBuffer nomfich;
	String dir_data=null;
	public File fich;
	public Hashtable mel_externes;
    String[] components;
    double P0,T0,Pref;
    double hv,sv,xx;
	int[]erreur=new int[1];
    public double[]res=new double[6];
    double[]args=new double[3];
	boolean testInit=false;
	String mixtureFileName;
    
    public ExtPropServer()throws Exception{
        super();
/*  //      type=getType();
        M=29;PC=10;TC=350; 
        M=29;PC=10;TC=350; //Attention : initialisations sans sens physique
        Tmini=278.15;  Tmaxi=448.15; 
//        chemForm="chemical formula";
        typeCorps=6;//corps externe de type isMixture
        chemForm="ThermoBlend mixture properties";
        vMixtures= new Vector();
  		mel_externes= new Hashtable();
  //		getMixtures();	*/
    }
  
    public Vector getMixtures()throws MixtureException{
		vMixtures= new Vector();
    	nomfich= new StringBuffer(mixtureFileName); 
	    dir_data=System.getProperty("user.dir")+File.separator+"mixtures"+File.separator;
		try{
			fich = new File(dir_data,nomfich.toString());
			lect_data(fich);
  		}
  		catch(Exception e){//en cas de problme, on gnre une exception pour le fichier error.txt
  			throw new MixtureException(getType());
  		}
      return vMixtures;
    }
  
    public String getSoftware(){
        return "external SPT";
    }

    public boolean isMolarFraction(){
        return false;
    }
    
        public void updateComp(String systType, double[] fractmol){

            selectedSyst=systType;
            //rcupration des informations sur le systme considr par la Hashtable
	        Vector liste_comp = (Vector)(mel_externes.get(selectedSyst));
	        
            selectedFile=(String)liste_comp.elementAt(0);//fichier de mlange du systme (XXX.mel)
            int nbComp=Util.lit_i((String)liste_comp.elementAt(1));//nombre de composants du systme
            fract_mol = fractmol;
            components=new String[nbComp];
	        for(int i=0;i<fract_mol.length;i++){
	           components[i]=(String)liste_comp.elementAt(i+2);//noms des composants
	        }
	        //coordonnes critiques (pour les corps purs)
	        PC=Util.lit_d((String)liste_comp.elementAt(nbComp+2));
	        TC=Util.lit_d((String)liste_comp.elementAt(nbComp+3));
	        //intervalle de dfinition des modles utiliss
	        Tmaxi=Util.lit_d((String)liste_comp.elementAt(nbComp+4));
	        Tmini=Util.lit_d((String)liste_comp.elementAt(nbComp+5));
	        //Pression et temprature des enthalpie, entropie et nergie interne de rfrence
	        P0=Util.lit_d((String)liste_comp.elementAt(nbComp+6));
	        T0=Util.lit_d((String)liste_comp.elementAt(nbComp+7));
    }
    


    public double f_dicho(double T, double x,String fonc){
        return 0;
    }
    
  	/**
	 * Lecture du fichier de donnes dfinissant les
	 * gaz composs
	 * 
	 * Reads the data file of the compound gases
	 * 
	 * @param fich File
	 * @param prot "true" if protected gas file
	 */
	 public void lect_data(File fich) throws Exception{
	    FileReader flux_fich=null;
	    BufferedReader flux_tamp=null;
		try{
			flux_fich = new FileReader(fich);
			flux_tamp = new BufferedReader(flux_fich);
			String ligne_data;

			ligne_data = flux_tamp.readLine();//premire ligne de commentaires
			StringTokenizer st = new StringTokenizer(ligne_data,"\t");

			//lignes de donnes
			StringBuffer test=new StringBuffer("");
			String compose="";
		    while (((ligne_data = flux_tamp.readLine())!= null)&& (!(test.toString().equals("Fin")))){
				//nom du gaz compos
				st = new StringTokenizer(ligne_data,"\t");
				String mixtureName = st.nextToken();
				String mixtureFile="";
				if(st.hasMoreTokens())mixtureFile= st.nextToken();
				int nbComp=0;
				if(st.hasMoreTokens())nbComp=Util.lit_i(st.nextToken());
				components=new String[nbComp] ;

				test.setLength(0);
				test.append(mixtureName);
 	            Object[]obj1=new Object[2];
				obj1[0]=mixtureName;
		        Vector liste_composes = new Vector();
 				liste_composes.addElement(mixtureFile);
 				liste_composes.addElement(Util.aff_i(nbComp));
				int j_dat=-1;
				if(st.hasMoreTokens()){
					for(int k=0;k<nbComp;k++){
						j_dat++;
						compose = st.nextToken();
						components[j_dat]=compose;
						liste_composes.addElement(compose);
			        }
			        M=Util.lit_d(Util.extr_value(ligne_data,"M"));
			        PC=Util.lit_d(Util.extr_value(ligne_data,"PC"));
			        liste_composes.addElement(Util.extr_value(ligne_data,"PC"));
			        TC=Util.lit_d(Util.extr_value(ligne_data,"TC"));
			        liste_composes.addElement(Util.extr_value(ligne_data,"TC"));
			        Tmaxi=Util.lit_d(Util.extr_value(ligne_data,"Tmaxi"));
			        liste_composes.addElement(Util.extr_value(ligne_data,"Tmaxi"));
			        Tmini=Util.lit_d(Util.extr_value(ligne_data,"Tmini"));
			        liste_composes.addElement(Util.extr_value(ligne_data,"Tmini"));
			        P0=Util.lit_d(Util.extr_value(ligne_data,"P0"));
			        liste_composes.addElement(Util.extr_value(ligne_data,"P0"));
			        T0=Util.lit_d(Util.extr_value(ligne_data,"T0"));
			        liste_composes.addElement(Util.extr_value(ligne_data,"T0"));
				
				}
				if(!mixtureName.equals("Fin")){
                   	mel_externes.put(mixtureName,liste_composes);//chargement dans la HashTable des rfrences du modle
				    obj1[1]=components;
	   				vMixtures.addElement(obj1);
	   			}
		    }
			flux_tamp.close();
			flux_fich.close();
	
		} 
		catch(FileNotFoundException e) {
		    String message="Le_fichier "+fich.getAbsolutePath()+" est introuvable\n Le mlange externe ne peut tre cr";  
		    JOptionPane.showMessageDialog(new JFrame(),message);
		    e.printStackTrace();
		    throw new Exception();
		}
		catch(IOException e) {
		    String message="Le_fichier "+fich.getAbsolutePath()+" est mal configur\n Le mlange externe ne peut tre cr";  
		    JOptionPane.showMessageDialog(new JFrame(),message);
		    e.printStackTrace();
		    throw new Exception();
		}
	}
    

}