/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import java.util.*;


public class FlowConfig 
{
    TechnoExch te;
    TechnoExch otherTe;
    String NuCorrel="",fCorrel="";
 	protected  String tab=new String("\t");
	protected  String ligne=new String("\n");
	protected double Nu;
	boolean specialCalculation=false;
	public double C1,a_Re,b_Pr,c_Visc,C2,d_Re,RR;
	boolean internalSetting=false;
	double laminarLimit=2000,turbulentLimit=8000;
	public boolean laminar=false,colebrook=true;
	public double NuLamin=7;
	public double gliss, voidFraction, ro_m, Kh=1;//calculs du taux de vide

    public FlowConfig (){
    }

    public FlowConfig (TechnoExch te){
        this.te=te;
		te.JLabel13.setText("length");
		otherTe=te.otherTe;
		setParameterValues();//modRG 07/2012
    }
    void setParameterValues(){//modRG 07/2012
        C1=0.023;a_Re=0.8;b_Pr=0.4;c_Visc=0.14;RR=0.001;
        C2=0.31;d_Re=-0.25;    	
    }
    
    public void setTechnoExch(TechnoExch te){
        this.te=te;
        C1=0.023;a_Re=0.8;b_Pr=0.4;c_Visc=0.14;RR=0.001;;
        C2=0.31;d_Re=-0.25;
		te.JLabel13.setText("length");
		otherTe=te.otherTe;
    }
    
    public String getCode(){return "flow config";}
    
	public String getClassDescription(){
	    return "basic class for flow configuration";
	}
            
	public double calcNu(double P){
	    return calcNuTube();
	}
    public double calcNuTube(){//Implmentation par dfaut
  /*      Corps lecorps=te.corps;
        double x=te.comp.amont.getXx();
        double Tthis=(te.comp.amont.getT()+te.comp.aval.getT())/2;
        te.initLambdaMu(Tthis, x, lecorps);
  
        //bulk viscosity
        double viscCorr=te.mu;
        
        //wall viscosity
        ExchangeDemo otherComp=te.hX.hotFluid;
        if(te.comp==te.hX.hotFluid)otherComp=te.hX.coldFluid;
        double Tother=(otherComp.amont.getT()+otherComp.aval.getT())/2;
        // wall temperature
        double Twall=(Tother+Tthis)/2.;
        te.initLambdaMu(Twall, x, lecorps);
   //     System.out.println("Tthis "+Tthis+"  viscosity "+viscCorr);
        viscCorr=viscCorr/te.mu;*/
 //       if(te.getRe()<2000)return 4.;
        calcMeanDensity(te.amont.V, te.aval.V, te.amont.X, te.aval.X);
        if(laminar){//si prise en compte laminaire
//	        te.Re=turbulentLimit;
	        double Nut=C1*Math.pow(turbulentLimit,a_Re)*Math.pow(te.getPr(),b_Pr);
	        double Nul=getNuLamin();
//	        te.Re=te.calcRe();
	        double Re=te.getRe();
	        if(Re<=laminarLimit)return Nul;
	        else if(Re>=turbulentLimit)return C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);
	        else{
	            double alpha=(Re-laminarLimit)/(turbulentLimit-laminarLimit);
	            return Nul+(Nut-Nul)*alpha;
	        }
	    }
	    else return C1*Math.pow(te.getRe(),a_Re)*Math.pow(te.getPr(),b_Pr);//*Math.pow(viscCorr,c_Visc);
    }
    
    protected double getNuLamin(){
        return NuLamin;
    }
    
	public double getNusselt(){return Nu;}
	
	public double calcDP(){
	    return calcDP(te.amont.V);
	}
	
	public double calcDP(double vl){
	    double dP;
	    double flow=te.getFlow();
	    double Ac=Util.lit_d(te.Ac_value.getText());
	    double dh=Util.lit_d(te.Dh_value.getText());
	    double L=Util.lit_d(te.L_value.getText());
	    double f=getFrictionFactor();
	    double C=flow*vl/Ac;
	    te.frictionFactor_value.setText(Util.aff_d(f,6));
	    dP=f*vl/2*flow*flow/Ac/Ac*L/dh/100000;//Perte rgulire en bar
	    double dPSing=Util.lit_d(te.dPSing_value.getText())*C*C/2/100000;//Perte singulire en bar
//	    System.out.println(te.getRe()+"\t"+te.mu+"\t"+RR+"\t"+C+"\t"+f+"\t"+dPSing+"\t"+dP);
	    dP=dP+dPSing;
	    return dP;
    }
/*
	public double calcDPdiff(){
        double Tsat=te.corps.lecorps.getSatTemperature(te.amont.P, 1);//pression d'vaporation
	    te.corps.lecorps.CalcPropCorps(Tsat,te.amont.P,1.);
	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
	    
	    return calcDP(v);
	}
*/
	public double calcDPdiff(){
        double Tsat=te.corps.lecorps.getSatTemperature(te.amont.P, 0);//pression d'vaporation
	    te.corps.lecorps.CalcPropCorps(Tsat-0.1,te.amont.P,0);
	    Vector vProp=te.corps.lecorps.getSubstProperties();
        Double f=(Double)vProp.elementAt(3);
        double v=f.doubleValue();
	    double dPl=calcDP(v);
	    double z= (1+Math.abs(te.aval.X-te.amont.X)*(te.ro_l/te.ro_v-1));
	    double y=(1+Math.abs(te.aval.X-te.amont.X)*(te.mu_l/te.mu_v-1));
  //      System.out.println(te.exchangeName+"  z "+z+"  te.ro_l "+te.ro_l+"  te.ro_v "+te.ro_v);	        
  //      System.out.println(te.exchangeName+"  y "+y+"  te.mu_l "+te.mu_l+"  te.mu_v "+te.mu_v);	        
	    y=Math.pow(y, -0.2);
	    double dPlv=z*y*dPl;
	    dPl=calcDP(te.amont.V);
	    double dPv=calcDP(te.aval.V);
 //       System.out.println("dPl "+dPl+"  dPv "+dPv+"  dPlv "+dPlv);	        

	    double zz=0;//deux cas selon qu'il s'agit d'un changeur ou d'un thermocoupleur
	    if(te.tHx!=null)zz=te.tHx.Al/te.tHx.A*dPl+te.tHx.Alv/te.tHx.A*dPlv+te.tHx.Av/te.tHx.A*dPv;
	    if(te.tTc!=null)zz=te.tTc.Al/te.tTc.A*dPl+te.tTc.Alv/te.tTc.A*dPlv+te.tTc.Av/te.tTc.A*dPv;
	    
	    return zz;
	}

	
	public double getFrictionFactor(){
	    double Re=te.getRe();
	    if(Re>2300){
	        if(colebrook){
	            double y=Math.pow(RR/3.71, 1.1);
	            double z=-0.781730067*Math.log(y+6.9/Re);
	            double f=1/z/z;
	            return f;
	        }
	        else{
	            return C2*Math.pow(Re, d_Re);
	        }
	    }
	    else{
	        return 64/Re;
	    }
    }
	
	public double getPressFactor(){
	    return 1;
    }
	public void setPressFactor(double fact){
    }
    
	//permet de faire un test de cohrence associ  une config 
	//par exemple, une tour de refroidissement ncessite de l'air comme corps
    public boolean testeConfig(){
        return true;
    }
    
	 //prise en compte du taux de vide pour le calcul de la charge en frigorigne
	 public void calcMeanDensity(double Vl, double Vv,double Xe,double Xs){
	        double fact=Vv/Vl;
	        if(Vv>Vl){//appel normal
	            gliss=Math.pow(fact,1./3.);//glissement S selon Zivi
    //	        voidFraction=Kh/(1.+gliss*(1.-te.amont.X)/te.amont.X/fact);//valeur au point amont
    //	        ro_m=voidFraction/Vv+(1.-voidFraction)/Vl;//valeur au point amont
                //calcul de la valeur moyenne de ro_m (intgration de l'quation prcdente)
	            double a, b, c;
	            a=Kh/Vl*(1./Vv-1./Vl);
	            b=1./Vl-gliss/Vv;
	            c=gliss/Vv;
	            ro_m=Math.abs((1./Vl+a/b)*(Xe-Xs)-a*c/b/b*Math.log((Xe+c/b)/(Xs+c/b)));
	        }
	        else if(Vv<Vl){//appel invers au cas o on entre en vapeur et sort en liquide
	            fact=1/fact;
	            double V=Vl;
	            Vl=Vv;
	            Vv=V;
	            gliss=Math.pow(fact,1./3.);//glissement S selon Zivi
    //	        voidFraction=Kh/(1.+gliss*(1.-te.amont.X)/te.amont.X/fact);//valeur au point amont
    //	        ro_m=voidFraction/Vv+(1.-voidFraction)/Vl;//valeur au point amont
                //calcul de la valeur moyenne de ro_m (intgration de l'quation prcdente)
	            double a, b, c;
	            a=Kh/Vl*(1./Vv-1./Vl);
	            b=1./Vl-gliss/Vv;
	            c=gliss/Vv;
	            ro_m=Math.abs((1./Vl+a/b)*(Xe-Xs)-a*c/b/b*Math.log((Xe+c/b)/(Xs+c/b)));
	        }
	        else{//cas monophasique
	            ro_m=1/Vl;
	        }
     }
	
	public double getMeanDensity(){
	    return ro_m;
	}
	/*
	
	public double get_f(){//facteur de frottement
//	    return 0.046*Math.pow(Re, 0.2);
	 //   return 0.03;
	    if(te.getRe()<2000)return 14./te.getRe();
	    else return 0.03;
	}
	*/
	public void readCompParameters(String ligne_data){
    //    C1=0.023;a_Re=0.8;b_Pr=0.4;c_Visc=0.14;
        String valeur;
        valeur=Util.extr_value(ligne_data, "C1");
        if(valeur!=null)C1=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "a_Re");
        if(valeur!=null)a_Re=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "b_Pr");
        if(valeur!=null)b_Pr=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "c_Visc");
        if(valeur!=null)c_Visc=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "C2");
        if(valeur!=null)C2=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "d_Re");
        if(valeur!=null)d_Re=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "RR");
        if(valeur!=null)RR=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "Kh");
        if(valeur!=null)Kh=Util.lit_d(valeur);
        valeur=Util.extr_value(ligne_data, "colebrook");
        if(valeur!=null)colebrook=Util.lit_b(valeur);
        valeur=Util.extr_value(ligne_data, "laminar");
        if(valeur!=null)laminar=Util.lit_b(valeur);
	}
	public void readCaract(String ligne_data){
    //    C1=0.023;a_Re=0.8;b_Pr=0.4;c_Visc=0.14;
        String valeur;
        valeur=Util.extr_value2(ligne_data, "C1");
        if(valeur!=null)C1=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "a_Re");
        if(valeur!=null)a_Re=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "b_Pr");
        if(valeur!=null)b_Pr=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "c_Visc");
        if(valeur!=null)c_Visc=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "C2");
        if(valeur!=null)C2=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "d_Re");
        if(valeur!=null)d_Re=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "RR");
        if(valeur!=null)RR=Util.lit_d(valeur);
        valeur=Util.extr_value2(ligne_data, "Kh");
        if(valeur!=null)Kh=Util.lit_d(valeur);
	}
    public String saveCaract(){
	    String h;
        h="C1="+Util.aff_d(C1)+":"
        +"a_Re="+Util.aff_d(a_Re)+":"
        +"b_Pr="+Util.aff_d(b_Pr)+":"
        +"c_Visc="+Util.aff_d(c_Visc)+":"
        +"C2="+Util.aff_d(C2)+":"
        +"d_Re="+Util.aff_d(d_Re)+":"
        +"RR="+Util.aff_d(RR)+":"
        +"Kh="+Util.aff_d(Kh)+":"
        +"colebrook="+Util.aff_b(colebrook)+":"
        +"laminar="+Util.aff_b(laminar)+":"
        ;
        return h;
    }
    public String saveCompParameters(){
	    String h;
        h="C1="+Util.aff_d(C1)+"\t"
        +"a_Re="+Util.aff_d(a_Re)+"\t"
        +"b_Pr="+Util.aff_d(b_Pr)+"\t"
        +"c_Visc="+Util.aff_d(c_Visc)+"\t"
        +"C2="+Util.aff_d(C2)+"\t"
        +"d_Re="+Util.aff_d(d_Re)+"\t"
        +"RR="+Util.aff_d(RR)+"\t"
        +"Kh="+Util.aff_d(Kh)+"\t"
        +"colebrook="+Util.aff_b(colebrook)+"\t"
        +"laminar="+Util.aff_b(laminar)+"\t"
        ;
        return h;
    }


}