/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.corps.*; 
import rg.thopt.*;

import java.util.*; 

import javax.swing.*;


public class PointThopt
{
    public double T,P,X,V,U,H,S,DTsat;
    Corps lecorps;
    String name,nomCorps="", presSetName="";
    boolean isTsatSet,isPsatSet;
	double W,Epsi,QPrime,Tprime,Tr,VPrime,Cond, M_sec, corrFactor;
    Projet proj;
    CorpsThopt corps;
	
	public PointThopt(Projet proj, String name){
	    this.proj=proj;
	    this.name=name;
	    try{
	        getProperties();
	    }
	    catch(Exception e){
	        String msg = "Error constructing the PointCorps name: "+ name;
	        JOptionPane.showMessageDialog(new JFrame(), msg);  
	        e.printStackTrace();
	    }
	    corps=new CorpsThopt(proj, nomCorps,lecorps);
	}
	
    /** Rcupre les proprits d'un point
    *<p>
	* Gets a point's properties
	*<p>
	* not to be overriden by PointThopt subclasses
	*/
    public void getProperties(){
	    String[] args=new String[2];
	    args[0]="point";//type of the element (see method getProperties(String[] args))
	    args[1]=name;//name of the process (see method getProperties(String[] args))
	    Vector vProp=proj.getProperties(args);
        lecorps=(Corps)vProp.elementAt(0);
        nomCorps=(String)vProp.elementAt(1);
        Double y=(Double)vProp.elementAt(2);
        T=y.doubleValue();
        y=(Double)vProp.elementAt(3);
	    P=y.doubleValue();
        y=(Double)vProp.elementAt(4);
	    X=y.doubleValue();
        y=(Double)vProp.elementAt(5);
	    V=y.doubleValue();
        y=(Double)vProp.elementAt(6);
	    U=y.doubleValue();
        y=(Double)vProp.elementAt(7);
	    H=y.doubleValue();
        y=(Double)vProp.elementAt(8);
	    S=y.doubleValue();
        y=(Double)vProp.elementAt(10);
	    DTsat=y.doubleValue();
	    String dum=(String)vProp.elementAt(9);
	    isTsatSet=Util.lit_b(Util.extr_value(dum));
	    dum=(String)vProp.elementAt(11);
	    isPsatSet=Util.lit_b(Util.extr_value(dum));//*/
	    
	    y=(Double)vProp.elementAt(12);
	    W=y.doubleValue();
	    y=(Double)vProp.elementAt(13);
	    Epsi=y.doubleValue();
	    y=(Double)vProp.elementAt(14);
	    QPrime=y.doubleValue();
	    y=(Double)vProp.elementAt(15);
	    Tprime=y.doubleValue();
	    y=(Double)vProp.elementAt(16);
	    Tr=y.doubleValue();
	    y=(Double)vProp.elementAt(17);
	    VPrime=y.doubleValue();
	    y=(Double)vProp.elementAt(18);
	    Cond=y.doubleValue();
	    y=(Double)vProp.elementAt(19);
	    M_sec=y.doubleValue();
	    if(vProp.size()>20){
	        presSetName=(String)vProp.elementAt(22);
	        y=(Double)vProp.elementAt(23);
	        corrFactor=y.doubleValue();
	    }
    }
    
    /** Met  jour les proprits d'un point
    *<p>
	* Updates a point's properties
	*<p>
	* not to be overriden by PointThopt subclasses
	*/
    public void update(boolean updateT, boolean updateP, boolean updateX, boolean updateCorrFactor, boolean melHum, String task, double value){
	    //attention : les signatures de longueurs diffrentes doivent gnrer des longueurs de Vector diffrentes
	    //pour traitement diffrenci par updatePoint de Projet
	    String[] args=new String[2];
         Vector vPoint=new Vector();
         vPoint.addElement(name);
         vPoint.addElement(Util.aff_b(updateT));
         vPoint.addElement(Util.aff_d(T));
         vPoint.addElement(Util.aff_b(updateP));
         vPoint.addElement(Util.aff_d(P));
         vPoint.addElement(Util.aff_b(updateX));
         vPoint.addElement(Util.aff_d(X));
         vPoint.addElement(Util.aff_b(melHum));
         vPoint.addElement(task);
         vPoint.addElement(Util.aff_d(value));
  //       vPoint.addElement(presSetName);
         vPoint.addElement(Util.aff_b(updateCorrFactor));//[10]
         vPoint.addElement(Util.aff_d(corrFactor));
         proj.updatePoint(vPoint);
	}
    
    /** Met  jour les proprits d'un point
    *<p>
	* Updates a point's properties
	*<p>
	* not to be overriden by PointThopt subclasses
	*/
    public void update(boolean updateT, boolean updateP, boolean updateX, boolean updateCorrFactor, boolean updateDTsat, boolean melHum, String task, double value){
	    //attention : les signatures de longueurs diffrentes doivent gnrer des longueurs de Vector diffrentes
	    //pour traitement diffrenci par updatePoint de Projet
	    String[] args=new String[2];
         Vector vPoint=new Vector();
         vPoint.addElement(name);//[0]
         vPoint.addElement(Util.aff_b(updateT));//[1]
         vPoint.addElement(Util.aff_d(T));//[2]
         vPoint.addElement(Util.aff_b(updateP));//[3]
         vPoint.addElement(Util.aff_d(P));//[4]
         vPoint.addElement(Util.aff_b(updateX));//[5]
         vPoint.addElement(Util.aff_d(X));//[6]
         vPoint.addElement(Util.aff_b(melHum));//[7]
         vPoint.addElement(task);//[8]
         vPoint.addElement(Util.aff_d(value));//[9]
  //       vPoint.addElement(presSetName);
         vPoint.addElement(Util.aff_b(updateCorrFactor));//[10]
         vPoint.addElement(Util.aff_d(corrFactor));//[11]
         vPoint.addElement(Util.aff_b(updateDTsat));//[12]
         vPoint.addElement(Util.aff_d(DTsat));//[13]
 //        System.out.println("updateDTsat "+DTsat);
         proj.updatePoint(vPoint);
	}
    
    /** Met  jour les proprits d'un point : version allge la plus courante
    *<p>
	* Updates a point's properties
	*<p>
	* not to be overriden by PointThopt subclasses
	*/
    public void update(boolean updateT, boolean updateP, boolean updateX){
	    //attention : les signatures de longueurs diffrentes doivent gnrer des longueurs de Vector diffrentes
	    //pour traitement diffrenci par updatePoint de Projet        
	    String[] args=new String[2];
         Vector vPoint=new Vector();
         vPoint.addElement(name);
         vPoint.addElement(Util.aff_b(updateT));
         vPoint.addElement(Util.aff_d(T));
         vPoint.addElement(Util.aff_b(updateP));
         vPoint.addElement(Util.aff_d(P));
         vPoint.addElement(Util.aff_b(updateX));
         vPoint.addElement(Util.aff_d(X));
         proj.updatePoint(vPoint);
        
    }
    
    
	//{{DECLARE_CONTROLS
	//}}
}