/*
Copyright Renaud GICQUEL 2005-2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import javax.swing.table.*;
import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 * Classe pour calculer un cycle vapeur en rgime non-nominal
 * 
 * le modle de turbine est celui de Stodola
 *
 * enfin, bon nombre de noms de composants sont entrs dans le code alors qu'ils devraient tre automatiquement retrouvs
 *
 * il faut enfin faire du mnage car de nombreux bouts de code inutiliss proviennent de la classe Thrust
 *
 * Cette classe illustre la manire dont une classe externe peut piloter des reparamtrages 
 * varis d'un projet de structure donne
 *
 * @author Renaud GICQUEL
 */
public class TechnoDesignPilot extends ExtPilot 
{
	boolean isInitialized=false;
	boolean isBuilt=false;
	String[]composant,nomComposant;
    String hxName, echSettings="",compressorName="";
	String[]technoProcesses={"TechnoNozzle","TechnoTurb","TechnoGenericTurboCompr","TechnoTurboCompr","VolumCompr","MultiStageMappedTurbine","MultiStageMappedTurboCompr"};
    String[]technoHxes={"TechnoHx","TechnoEvapoCondensor","TechnoEvaporator","TechnoCondensor"};
    Vector vProcessTD_List,vHxTD_list,vTD_List,vTechnoProcess,vTechnoHx;
    TechnoHx technoEchangeur;
    double Te,Tf,massFlow, DTsurch, DTssrefr, Aech, Uech, AechReel, U_ech, Preservoir;
    double tauTurb, DeltaHech, mCpmin, mCpmax, NUT,R,epsilon, AdesignEch, DeltaH;
    
    double UAech, T2,Tech, Pech,Vech,Hech, mCpEau, mCpAir, lambdaVol, N_value, Vs;
        
    PointThopt amontChaud, avalChaud, amontFroid, avalFroid, amontCompr;
    
	String tab=new String("\t");
	String ligne=new String("\n");
	
	private Object[][] data_t;
	private Object[] nom_t;
    private TableModel  dataModelt;
	JScrollPane scrollpanet;
	JTableHeader JTMt;
	JTable tableViewt;
	

	public TechnoDesignPilot()
	{
		//{{INIT_CONTROLS
		setTitle("Generic pilot for technological design");
		getContentPane().setLayout(null);
		setSize(640,590);
		setVisible(false);
		bInitialSettings.setText("Set the technological design screens");
		bInitialSettings.setActionCommand("load");
		getContentPane().add(bInitialSettings);
		bInitialSettings.setBounds(192,0,288,36);
		JLabel10.setText("Design settings");
		getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel10.setBounds(12,0,553,25);
		bMakeDesign.setText("Design the selected components");
		bMakeDesign.setActionCommand("Design the selected components");
		getContentPane().add(bMakeDesign);
		bMakeDesign.setBounds(132,372,252,37);
		bSuppress.setText("Suppress");
		bSuppress.setActionCommand("Suppress");
		getContentPane().add(bSuppress);
		bSuppress.setForeground(java.awt.Color.red);
		bSuppress.setBounds(492,0,143,33);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bInitialSettings.addActionListener(lSymAction);
		bMakeDesign.addActionListener(lSymAction);
		bSuppress.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		type="generic techno design pilot";
		vProcessTD_List=new Vector();
		vHxTD_list=new Vector();
	    
	    
	    data_t= new Object[0][3];
	    setTable_t();	
		getContentPane().add(scrollpanet);
		scrollpanet.setBounds(0,50,500,310);
		scrollpanet.setBackground(getBackground());
		tableViewt.setBounds(0,50,500,300);

	
		SymMouse aSymMouse = new SymMouse();
		tableViewt.addMouseListener(aSymMouse);
	}

    /**
    * returns the component type 
    
    public String getType(){
        return type;
    }**/
    
	public String getClassDescription(){
	    return "generic pilot for technological design\n\n\nauthor : R. Gicquel september 2008";
	}
    
    void setupProject(){
        //on rcupre ici les instances des transfos externes dont on a besoin
        //afin d'accder  leurs diffrents paramtres pour les calculs ultrieurs
        
  }
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == TechnoDesignPilot.this)
			Thrust_WindowClosing(event);
		}
	}

	void Thrust_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JButton bInitialSettings = new javax.swing.JButton();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JButton bMakeDesign = new javax.swing.JButton();
	javax.swing.JButton bSuppress = new javax.swing.JButton();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bInitialSettings)
				bInitialSettings_actionPerformed(event);
			else if (object == bMakeDesign)
				bMakeDesign_actionPerformed(event);
			else if (object == bSuppress)
				bSuppress_actionPerformed(event);
			
			
			
			
		}
	}

	public void init_(){
		isInitialized=true;
		proj=getProjet();
		setupProject();
		
		//On rcupre la liste et le type des composants prsents dans l'diteur de schmas
		String[]listComp=proj.getEditorComponentList();
		composant=new String[listComp.length];
		nomComposant=new String[listComp.length];
        String[] args=new String[2];
        vTechnoProcess=new Vector();
        String amont="";
        String aval="";
		
		//on en extrait les noms des transfos du noyau dont on a besoin
		// savoir le compresseur et la chambre de combustion
        for(int i=0;i<listComp.length;i++){
		    composant[i]=Util.extr_value(listComp[i], "type");
		    nomComposant[i]=Util.extr_value(listComp[i], "name");
            System.out.println(composant[i]+"\t"+nomComposant[i]);

            args=new String[2];
            args[0]="process";
            args[1]=nomComposant[i];
            try{
                Vector vProp=proj.getProperties(args);
                amont=(String)vProp.elementAt(1);//gets the upstream point name
                aval=(String)vProp.elementAt(2);//gets the downstream point name
                System.out.println(amont+"\t"+aval);
                if((composant[i].equals("Compression"))||(composant[i].equals("Expansion"))||(composant[i].equals("Exchange"))){
                    Object[]obj=new Object[4];
                    obj[0]=composant[i];
                    obj[1]=nomComposant[i];
                    obj[2]=amont;
                    obj[3]=aval;
                    vTechnoProcess.addElement(obj);
                }
                
            }
            catch(Exception npe){
      //          npe.printStackTrace();
            }
            double x=0;
        
        }
        
        System.out.println();
		//On rcupre la liste des changeurs
        String[]listHX=proj.getHxList ();//ensuite, il faut utiliser getProperties

        vTechnoHx=new Vector();
        for(int i=0;i<listHX.length;i++){

            String hotFluid="";
            String coldFluid="";
            args=new String[2];
            args[0]="heatEx";
            args[1]=listHX[i];
            try{
                Vector vProp=proj.getProperties(args);
                hotFluid=(String)vProp.elementAt(0);
                coldFluid=(String)vProp.elementAt(1);
                System.out.println(hotFluid+"\t"+coldFluid);
                args[0]="process";
                args[1]=hotFluid;
                vProp=proj.getProperties(args);
                amont=(String)vProp.elementAt(1);//gets the upstream point name
                aval=(String)vProp.elementAt(2);//gets the downstream point name
                System.out.println(amont+"\t"+aval);
                args[1]=coldFluid;
                vProp=proj.getProperties(args);
                String amontFroid=(String)vProp.elementAt(1);//gets the upstream point name
                String avalFroid=(String)vProp.elementAt(2);//gets the downstream point name
                System.out.println(amontFroid+"\t"+avalFroid);
                
                Object[]obj=new Object[7];
                obj[0]=listHX[i];
                obj[1]=hotFluid;
                obj[2]=amont;
                obj[3]=aval;
                obj[4]=coldFluid;
                obj[5]=amontFroid;
                obj[6]=avalFroid;
                vTechnoHx.addElement(obj);
                
                for(int k=0;k<vTechnoProcess.size();k++){
                    Object[]ob=new Object[4];
                    ob=(Object[])vTechnoProcess.elementAt(k);
                    if((ob[0].equals("Exchange"))&&(ob[1].equals(hotFluid))){
                        vTechnoProcess.removeElementAt(k);
                        break;
                    }
                }
                for(int k=0;k<vTechnoProcess.size();k++){
                    Object[]ob=new Object[4];
                    ob=(Object[])vTechnoProcess.elementAt(k);
                    if((ob[0].equals("Exchange"))&&(ob[1].equals(coldFluid))){
                        vTechnoProcess.removeElementAt(k);
                        break;
                    }
                }

                
            }
            catch(Exception npe){
    //            npe.printStackTrace();
            }
        
        }
        
            
      for(int i=0;i<vTechnoProcess.size();i++){
            Object[]obj=new Object[4];
            obj=(Object[])vTechnoProcess.elementAt(i);
            String type=(String)obj[0];
            PointThopt Amont=new PointThopt(proj, (String)obj[2]);
            PointThopt Aval=new PointThopt(proj, (String)obj[3]);
            ExtTechnoDesign technoProcess=null;
            String typeTD="";
            typeTD=getProcessTD_type((String)obj[1]);
	    //"TechnoNozzle","TechnoTurb","TechnoGenericTurboCompr","TechnoTurboCompr","VolumCompr"
            if(type.equals("Compression")){
                
                if(typeTD.equals("TechnoTurboCompr")){
                    technoProcess=new TechnoTurboCompr(proj, (String)obj[1], Amont, Aval);
                }
                else if(typeTD.equals("TechnoGenericTurboCompr")){
                    technoProcess=new TechnoGenericTurboCompr(proj, (String)obj[1], Amont, Aval);
                }
                else if(typeTD.equals("MultiStageMappedTurboCompr")){
                    technoProcess=new MultiStageMappedTurboCompr(proj, (String)obj[1], Amont, Aval);
                }
                else {
                    technoProcess=new VolumCompr(proj, (String)obj[1], Amont, Aval);
                }
		    }
		    else if(type.equals("Expansion")){
		        if(typeTD.equals("TechnoNozzle")){
		            technoProcess=new TechnoNozzle(proj, (String)obj[1], Amont, Aval);
		        }
		        if(typeTD.equals("MultiStageMappedTurbine")){
		            technoProcess=new MultiStageMappedTurbine(proj, (String)obj[1], Amont, Aval);
		        }
		        else {
		            technoProcess=new TechnoTurb(proj, (String)obj[1], Amont, Aval);
		            typeTD="TechnoTurb";
		        }
		    }
		    else if(type.equals("Exchange")){
		        technoProcess=new TechnoExch(proj, (String)obj[1], Amont, Aval);
		        typeTD="TechnoExch";
		    }
	        addTechnoVector(technoProcess);
            Object[]ob=new Object[2];
	        ob[0]=obj[1];
	        ob[1]=typeTD;
	        int k=-1;
	        for(int j=0;j<vProcessTD_List.size();j++){
	             Object[]obje=new Object[2];
	             obje=(Object[])vProcessTD_List.elementAt(j);
	             if(obje[0].equals(obj[1])){
	                k=j;
	                break;
	             }
	        }
	        if(k==-1)vProcessTD_List.addElement(ob);// ne faire que s'il n'existe pas
	        else vProcessTD_List.setElementAt(ob,k);
	    }
    
        for(int i=0;i<vTechnoHx.size();i++){
            Object[]obj=new Object[7];
            obj=(Object[])vTechnoHx.elementAt(i);
            PointThopt Amont=new PointThopt(proj, (String)obj[2]);
            PointThopt Aval=new PointThopt(proj, (String)obj[3]);
            PointThopt AmontFroid=new PointThopt(proj, (String)obj[5]);
            PointThopt AvalFroid=new PointThopt(proj, (String)obj[6]);
            TechnoHx technoExch=null;
            String typeTD=getHxTD_type((String)obj[0]);
//	    "TechnoHx","TechnoEvapoCondensor","TechnoEvaporator","TechnoCondensor"
		    if(typeTD.equals("TechnoEvapoCondensor")){
		        technoExch=new TechnoEvapoCondensor(proj, (String)obj[0], Amont, Aval, AmontFroid, AvalFroid);
		    }
		    else if(typeTD.equals("TechnoEvaporator")){
		        technoExch=new TechnoEvaporator(proj, (String)obj[0], Amont, Aval, AmontFroid, AvalFroid);
		    }
		    else if(typeTD.equals("TechnoCondensor")){
		        technoExch=new TechnoCondensor(proj, (String)obj[0], Amont, Aval, AmontFroid, AvalFroid);
		    }
		    else {
		        technoExch=new TechnoHx(proj, (String)obj[0], Amont, Aval, AmontFroid, AvalFroid);
		    }
	        addTechnoVector(technoExch);
            Object[]ob=new Object[2];
	        ob[0]=obj[0];
	        ob[1]=typeTD;
	        int k=-1;
	        for(int j=0;j<vHxTD_list.size();j++){
	             Object[]obje=new Object[2];
	             obje=(Object[])vHxTD_list.elementAt(j);
	             if(obje[0].equals(obj[0])){
	                k=j;
	                break;
	             }
	        }
	        if(k==-1)vHxTD_list.addElement(ob);// ne faire que s'il n'existe pas
	        else vHxTD_list.setElementAt(ob,k);
	    }

            double x=0;
		setupTechnoDesigns(vTechno);
		
        setup_vTD_List();
  
        updateTablet();
        
	}
	
	
	void setup_vTD_List(){
		vTD_List=new Vector();
        for(int i=0;i<vTechnoProcess.size();i++){
            Object[]obj=new Object[4];
            obj=(Object[])vTechnoProcess.elementAt(i);
            Object[]ob=new Object[9];
            ob[0]=obj[0];
            ob[1]=getProcessTD_type((String)obj[1]);
            ob[2]=obj[1];ob[3]=obj[2];ob[4]=obj[3];
            vTD_List.addElement(ob);
        }
        for(int i=0;i<vTechnoHx.size();i++){
            Object[]obj=new Object[7];
            obj=(Object[])vTechnoHx.elementAt(i);
            Object[]ob=new Object[9];
            ob[0]="HeatEx";
            ob[1]=getHxTD_type((String)obj[0]);
            for(int k=0;k<7;k++){
                ob[k+2]=obj[k];
            }
            vTD_List.addElement(ob);
        }	
    }
	
	void bInitialSettings_actionPerformed(java.awt.event.ActionEvent event){
	//    if(!isInitialized)
	    init_();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	                            
        String[] args=new String[2];
        args[0]="project";
        args[1]="";
        Vector vProp=proj.getProperties(args);
        String flowUnit=(String)vProp.elementAt(0);
        if(!flowUnit.equals("kg/s")){
	        String msg = "Watch out! the flow rate unit should be\"kg/s\".\nYou may have discrepancies between your units \nand those used for heat exchanger design";
	        JOptionPane.showMessageDialog(this, msg);  
        }
	        
	}
	
	String getProcessTD_type(String nomProcess){
	    //"TechnoNozzle","TechnoTurb","TechnoGenericTurboCompr","TechnoTurboCompr","VolumCompr"
	    //vProcessTD_List,vHxTD_list;
	    for(int i=0;i<vProcessTD_List.size();i++){
	        Object[]obj=new Object[2];
	        obj=(Object[])vProcessTD_List.elementAt(i);
	        String nom=(String)obj[0];
	        String nomTD=(String)obj[1];
	        if(nomProcess.equals(nom)){
	            return nomTD;
	        }
	    }
	    return "VolumCompr";
	}
	
	String getHxTD_type(String nomHx){
//	    "TechnoHx","TechnoEvapoCondensor","TechnoEvaporator","TechnoCondensor"
	    for(int i=0;i<vHxTD_list.size();i++){
	        Object[]obj=new Object[2];
	        obj=(Object[])vHxTD_list.elementAt(i);
	        String nom=(String)obj[0];
	        String nomTD=(String)obj[1];
	        if(nomHx.equals(nom)){
	            return nomTD;
	        }
	    }
	    return "TechnoHx";
	}
	
	
	public void readCompParameters(String ligne_data){
	    String value="";
	    value=Util.extr_value(ligne_data, "nProc");
	    int n=0;
	    if(!value.equals(""))n=Util.lit_i(value);
	    for(int i=0;i<n;i++){
	        String code="nProc"+Util.aff_i(i);
	        String nom=Util.extr_value(ligne_data, code);
	        code="nProc_"+Util.aff_i(i);
	        String nomTD=Util.extr_value(ligne_data, code);
	        Object[]obj=new Object[2];
	        obj[0]=nom;
	        obj[1]=nomTD;
	        vProcessTD_List.addElement(obj);
	    }
	    
	    value=Util.extr_value(ligne_data, "nHx");
	    if(!value.equals(""))n=Util.lit_i(value);
	    for(int i=0;i<n;i++){
	        String code="nHx"+Util.aff_i(i);
	        String nom=Util.extr_value(ligne_data, code);
	        code="nHx_"+Util.aff_i(i);
	        String nomTD=Util.extr_value(ligne_data, code);
	        Object[]obj=new Object[2];
	        obj[0]=nom;
	        obj[1]=nomTD;
	        vHxTD_list.addElement(obj);
	    }//*/
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h+"nProc="+Util.aff_i(vProcessTD_List.size())+tab;
	    for(int i=0;i<vProcessTD_List.size();i++){
	        Object[]obj=new Object[2];
	        obj=(Object[])vProcessTD_List.elementAt(i);
	        String nom=(String)obj[0];
	        String nomTD=(String)obj[1];
	        h=h+"nProc"+Util.aff_i(i)+"="+nom+tab;
	        h=h+"nProc_"+Util.aff_i(i)+"="+nomTD+tab;
	    }
	    ;
	    h=h+"nHx="+Util.aff_i(vHxTD_list.size())+tab;
	    for(int i=0;i<vHxTD_list.size();i++){
	        Object[]obj=new Object[2];
	        obj=(Object[])vHxTD_list.elementAt(i);
	        String nom=(String)obj[0];
	        String nomTD=(String)obj[1];
	        h=h+"nHx"+Util.aff_i(i)+"="+nom+tab;
	        h=h+"nHx_"+Util.aff_i(i)+"="+nomTD+tab;
	    }
        return h;
    }
	


	/**
	 * manages JTable mouse double-clicks
	 */
void Projet_mousePressed(java.awt.event.MouseEvent event)
{
	Object object = event.getSource();
	int nb_click=event.getClickCount();
	if(nb_click>=2){
	  	
	    if (object == tableViewt){
	        int line=tableViewt.getSelectedRow();
	        String nomComp=(String)data_t[line][0];
	        String nomTD=(String)data_t[line][2];
	        String typeComp=(String)data_t[line][1];
	        int nPoints=vTD_List.size();
//	        data_t= new Object[nPoints][4];
	        int l=-1;
	        String tdType="";
	        Object[]obj=new Object[9];
	        for(int k=0;k<nPoints;k++){
	            obj=(Object[])vTD_List.elementAt(k);
		        String nom=(String)obj[2];
		        String td=(String)obj[1];
		        tdType=(String)obj[0];
		        if((nom.equals(nomComp))&&(td.equals(nomTD))){
		            l=k;
		            break;
		        }
		    }
		    if(l!=-1){
		        //demande "dsirez-vous changer de TechnoDesign"		        
		        boolean resp=Util.Confirm(this,"Change the TechnoDesign", 
	            "Cancel","Watch out!","Do you want to change the TechnoDesign of this component?");
                if(resp){
                    String[]listTD;
                    if(tdType.equals("HeatEx"))listTD=technoHxes;
                    else listTD=technoProcesses;
          	            
		            //Si oui, propose liste
		            String newTd=JCombo.DemandeCombo(this,"Choose the TechnoDesign",listTD);
		            //aprs choix, instanciation du nouveau TechnoDesign 
	                if(newTd!=null){
	                    if(tdType.equals("HeatEx")){
                            PointThopt Amont=new PointThopt(proj, (String)obj[4]);
                            PointThopt Aval=new PointThopt(proj, (String)obj[5]);
                            PointThopt AmontFroid=new PointThopt(proj, (String)obj[7]);
                            PointThopt AvalFroid=new PointThopt(proj, (String)obj[8]);
                            TechnoHx technoExch=null;
		                    if(newTd.equals("TechnoEvapoCondensor")){
		                        technoExch=new TechnoEvapoCondensor(proj, nomComp, Amont, Aval, AmontFroid, AvalFroid);
		                    }
		                    else if(newTd.equals("TechnoEvaporator")){
		                        technoExch=new TechnoEvaporator(proj, nomComp, Amont, Aval, AmontFroid, AvalFroid);
		                    }
		                    else if(newTd.equals("TechnoCondensor")){
		                        technoExch=new TechnoCondensor(proj, nomComp, Amont, Aval, AmontFroid, AvalFroid);
		                    }
		                    else {
		                        technoExch=new TechnoHx(proj, nomComp, Amont, Aval, AmontFroid, AvalFroid);
		                    }
		                    updateTechnoVector(technoExch);
                            Object[]ob=new Object[2];
	                        ob[0]=obj[2];
	                        ob[1]=newTd;
	                        int k=-1;
	                        for(int j=0;j<vHxTD_list.size();j++){
	                            Object[]obje=new Object[2];
	                            obje=(Object[])vHxTD_list.elementAt(j);
	                            if(obje[0].equals(obj[2])){
	                                k=j;
	                                break;
	                            }
	                        }
	                        if(k!=-1)vHxTD_list.setElementAt(ob,k);
	                    }
	                    else{
                            String type=(String)obj[0];
                            String amont=(String)obj[3];
                            String aval=(String)obj[4];
                            PointThopt Amont=new PointThopt(proj, amont);
                            PointThopt Aval=new PointThopt(proj, aval);
                            ExtTechnoDesign technoProcess=null;
                            if(type.equals("Compression")){
                                if(newTd.equals("TechnoTurboCompr")){
                                    technoProcess=new TechnoTurboCompr(proj, nomComp, Amont, Aval);
                                }
                                else if(newTd.equals("TechnoGenericTurboCompr")){
                                    technoProcess=new TechnoGenericTurboCompr(proj, nomComp, Amont, Aval);
                                }
                                else {
                                    technoProcess=new VolumCompr(proj, nomComp, Amont, Aval);
                                }
		                    }
		                    else if(type.equals("Expansion")){
		                        if(newTd.equals("TechnoNozzle")){
		                            technoProcess=new TechnoNozzle(proj, nomComp, Amont, Aval);
		                        }
		                        else {
		                            technoProcess=new TechnoTurb(proj, nomComp, Amont, Aval);
		                        }
		                    }
		                    else if(type.equals("Exchange")){
		                        technoProcess=new TechnoExch(proj, nomComp, Amont, Aval);
//		                        typeTD="TechnoExch";
		                    }
		                    
		                    updateTechnoVector(technoProcess);
		                    Object[]ob=new Object[2];
	                        ob[0]=obj[2];
	                        ob[1]=newTd;
	                        int k=-1;
	                        for(int j=0;j<vProcessTD_List.size();j++){
	                            Object[]obje=new Object[2];
	                            obje=(Object[])vProcessTD_List.elementAt(j);
	                            if(obje[0].equals(obj[2])){
	                                k=j;
	                                break;
	                            }
	                        }
	                        if(k!=-1)vProcessTD_List.setElementAt(ob,k);
	                    }
	                }
		            //mise  jour des Vector concerns 
	                setup_vTD_List();
      	            updateTablet();
		            setupTechnoDesigns(vTechno);
                }
		    }

	    }
	
	  }
	}
	
/**
 * updates the Subordinate JTable
 */
public void updateTablet(){
	int nPoints=vTD_List.size();
	data_t= new Object[nPoints][3];
	for(int k=0;k<nPoints;k++){
	    try{
	        Object[]obj=new Object[9];
	        obj=(Object[])vTD_List.elementAt(k);
		    data_t[k][0]=(String)obj[2];//nom
		    data_t[k][1]=(String)obj[0];//type 
		    data_t[k][2]=(String)obj[1];//type de TechnoDesign
//		    data_t[k][3]="";
		}
		catch(ClassCastException c){}
	}
	tableViewt.revalidate();
	setVisible(false) ;
    show() ;
}

/**
 * generates the Techno Design JTable
 */
private void setTable_t(){
	nom_t= new Object[3];
	nom_t[0]="name";  
	nom_t[1]="type";   
	nom_t[2]="TechnoDesign";   
//	nom_t[3]="?";   

	dataModelt = new AbstractTableModel() {

		public int getColumnCount() { return nom_t.length; }
		public int getRowCount() { return data_t.length;}
		public Object getValueAt(int row, int col) {return data_t[row][col];}

		public String getColumnName(int column) {return (String) nom_t[column];}
		public boolean isCellEditable(int row, int col) {return false;}
			};
		tableViewt = new JTable(dataModelt);
		JTMt=tableViewt.getTableHeader();

		scrollpanet = new JScrollPane(tableViewt);
		scrollpanet.setPreferredSize(new Dimension(400,150));
	}
	

class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mousePressed(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
				Projet_mousePressed(event);
		}
	}
	
    ExtTechnoDesign getTechnoDesign(String nomComp, String nomTD){
        ExtTechnoDesign etd=null;
        for(int i=0;i<vTechno.size();i++){
		Object[]ob=new Object[5];
            ob=(Object[])vTechno.elementAt(i);
            if((ob[0].equals(nomComp))&&(ob[2].equals(nomTD))){
                etd=(ExtTechnoDesign)ob[1] ;
                break;
            }
        }
        return etd;
    }
	
	

	void bMakeDesign_actionPerformed(java.awt.event.ActionEvent event)
	{
	    int[] lines=tableViewt.getSelectedRows();
	    for(int i=0;i<lines.length;i++){
	        String nomComp=(String)data_t[lines[i]][0];
	        String nomTD=(String)data_t[lines[i]][2];
	        String typeComp=(String)data_t[lines[i]][1];
	        int nPoints=vTD_List.size();
	        int l=-1;
	        Object[]obj=new Object[9];
	        String tdType="";
	        for(int k=0;k<nPoints;k++){
	            obj=(Object[])vTD_List.elementAt(k);
		        String nom=(String)obj[2];
		        String td=(String)obj[1];
		        tdType=(String)obj[0];
		        if((nom.equals(nomComp))&&(td.equals(nomTD))){
		            l=k;
		            break;
		        }
		    }
		    if(l!=-1){
	            if(tdType.equals("HeatEx")){
	                TechnoHx technoDesign=(TechnoHx)getTechnoDesign(nomComp, nomTD);
	                technoDesign.techc.amont.getProperties();
	                technoDesign.techc.aval.getProperties();
	                technoDesign.techf.amont.getProperties();
	                technoDesign.techf.aval.getProperties();
	                String[]args=new String[2];
                    args[0]="heatEx";
                    args[1]=nomComp;
                    Vector vProp=proj.getProperties(args);
                    Double f=(Double)vProp.elementAt(15);
                    UAech=f.doubleValue();

	                technoDesign.UA=UAech;
	                technoDesign.makeDesign();
//	                System.out.println("pass technoHx.makeDesign() ");
	            }
	            else{
	                ExtTechnoDesign technoDesign=getTechnoDesign(nomComp, nomTD);
	                technoDesign.aval.getProperties();
	                technoDesign.amont.getProperties();
	                technoDesign.makeDesign();
	            }		
	        }
	    }
			 
	}

	void bSuppress_actionPerformed(java.awt.event.ActionEvent event)
	{
	    int[] lines=tableViewt.getSelectedRows();
	    if(lines.length!=1){
	        String msg = "Select a single line";
	        JOptionPane.showMessageDialog(this, msg);  
	    }
	    else{
	    for(int i=0;i<lines.length;i++){
	        String nomComp=(String)data_t[lines[i]][0];
	        String nomTD=(String)data_t[lines[i]][2];
	        String typeComp=(String)data_t[lines[i]][1];
	        int nPoints=vTD_List.size();
	        int l=-1;
	        Object[]obj=new Object[9];
	        String tdType="";
	        for(int k=0;k<nPoints;k++){
	            obj=(Object[])vTD_List.elementAt(k);
		        String nom=(String)obj[2];
		        String td=(String)obj[1];
		        tdType=(String)obj[0];
		        if((nom.equals(nomComp))&&(td.equals(nomTD))){
		            l=k;
		            vTD_List.removeElementAt(k);
		            break;
		        }
		    }
		    if(l!=-1){
	            for(int k=0;k<vTechno.size();k++){
		            Object[]ob=new Object[5];
                        ob=(Object[])vTechno.elementAt(k);
                        if((ob[0].equals(nomComp))&&(ob[2].equals(nomTD))){
		                    vTechno.removeElementAt(k);
                            break;
                        }
	            }
	        }
	    }
	    updateTablet();
		setupTechnoDesigns(vTechno);
	}
	}
}