/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;


public class TechnoGenericTurboCompr extends TechnoTurboCompr
{
    
    
	public TechnoGenericTurboCompr()
	{
        super();
        JPanel1.add(N_value);
        JPanel1.add(JLabel10);
        
    }
    
    public TechnoGenericTurboCompr(Projet proj, String compressorName, PointThopt amont, PointThopt aval){
		super(proj, compressorName, amont, aval);
        JPanel1.add(N_value);
        JPanel1.add(JLabel10);
	}

    public TechnoGenericTurboCompr(Projet proj, String compressorName){
		super(proj, compressorName);
        JPanel1.add(N_value);
        JPanel1.add(JLabel10);
	}

  	public String getClassDescription(){
	    return "generic turbocompressor class\n\nauthor : R. Gicquel  march 2008\n\nRef : archive ";
	}
	
    public String getType(){
        return "generic turbocompressor";
    }
    public String getClassName(){
        return "TechnoGenericTurboCompr";
    }
    
    /*
    * Les mthodes ayant pour signature (double massFlow) sont utilises par les algorithmes de recherche de solution
    * lorsque le dbit qui traverse le compresseur n'est pas connu
    * Lorsqu'il s'agit du dbit du composant, la mthode sans signature est la bonne. Elle fait appel  getFlow()
    * Les mthodes faisant appel  (double reducedFlow) ne peuvent pas tre appeles de l'extrieur
    */
	
    /*
    * Rsolution de l'quation 17.5.2
    * 
    */
    double getComprReducedFlow(double massFlowRate){
	    amont.getProperties();
	    N=Util.lit_d(N_value.getText());
	    Kc=Util.lit_d(Kc_value.getText());
	    
        double reducedFlow=massFlowRate*amont.T/Kc/N/amont.P;
	    return reducedFlow;
    }
 
    /*
    * Rsolution de l'quation 17.5.3
    * 
    */
	private double getPsi(double reducedFlow){
	    double alpha=Util.lit_d(psiCoeff_value.getText());
	    double beta=Util.lit_d(phiPsiMax_value.getText());
	    double delta=Util.lit_d(psiMax_value.getText());
	    double psi=alpha*(reducedFlow-beta)*(reducedFlow-beta)+delta;
	    return psi;
	}

    /*
    * Rsolution de l'quation 17.5.4
    * 
    */
	double getPressureRatio(double massFlow){
	    N=Util.lit_d(N_value.getText());
	    
	    double reducedFlow=getComprReducedFlow(massFlow);
	    double psi=getPsi(reducedFlow);
	    double D=Util.lit_d(D_value.getText());
	    CorpsThopt corps=amont.corps;
	    corps.lecorps.CalcPropCorps (amont.T, amont.P, 1);
	    corps.getSubstProperties();
	    double H=corps.H;
	    corps.lecorps.CalcPropCorps (amont.T-1, amont.P, 1);
	    corps.getSubstProperties();
	    double Cp=1000.*(H-corps.H);
	    double coeff=(Math.PI*D/60)*(Math.PI*D/60)/2/Cp;
	    double puissFactor=psi/amont.T*N*N*coeff;
	    double f=1+puissFactor;
	    double ratio=Math.pow(f, 1.4/0.4);// modifier pour tenir compte de gamma rel
	    return ratio;
	}
	
	double getDiameter(double massFlow, double ratio){
	    N=Util.lit_d(N_value.getText());
	    
	    double reducedFlow=getComprReducedFlow(massFlow);
	    double psi=getPsi(reducedFlow);
//	    double D=Util.lit_d(D_value.getText());
	    CorpsThopt corps=amont.corps;
	    corps.lecorps.CalcPropCorps (amont.T, amont.P, 1);
	    corps.getSubstProperties();
	    double H=corps.H;
	    corps.lecorps.CalcPropCorps (amont.T-1, amont.P, 1);
	    corps.getSubstProperties();
	    double Cp=1000.*(H-corps.H);
//	    double coeff=(Math.PI*D/60)*(Math.PI*D/60)/2/Cp;
	    double f=Math.pow(ratio, 0.4/1.4);// modifier pour tenir compte de gamma rel
	    double puissFactor=f-1;
	    double coeff =puissFactor/(psi/amont.T*N*N);
	    double D=Math.pow(coeff*2*Cp, 0.5)*60/Math.PI;
	    return D;
	}
	
	double getPressureRatio(){
	    return getPressureRatio(getFlow());
	}
    
	double getRisentr(double massFlow){
	    double reducedFlow=getComprReducedFlow(massFlow);
	    return getCompressionEfficiency(reducedFlow);
	}
	    
    /*
    * Rsolution de l'quation donnant le rendement isentropique
    * 
    */
	private double getCompressionEfficiency(double reducedFlow){
	    double eta=(Util.lit_d(etaCoeff_value.getText())*
	        (reducedFlow-Util.lit_d(phiEtaMax_value.getText()))*
	        (reducedFlow-Util.lit_d(phiEtaMax_value.getText())))+
	        Util.lit_d(etaMax_value.getText());
	    if(eta<0.6)eta=0.6;
	    return eta;
	}

	public void makeDesign(){
	    N=Util.lit_d(N_value.getText());
	    r_compr=aval.P/amont.P;
	    double r_isentr=getRisentr();
	    risentr_value.setText(Util.aff_d(r_isentr,4));
	    double val=getFlow();
	    mc_value.setText(Util.aff_d(getComprReducedFlow(val),4));
	    m_value.setText(Util.aff_d(val,4));
	}
	
	public double[] getNlim(){
	    double phiMax=Util.lit_d(phiPsiMax_value.getText());
	    double psiMax=Util.lit_d(psiMax_value.getText());
	    double psiCoeff=Util.lit_d(psiCoeff_value.getText());
	    double z=-psiMax/psiCoeff;
	    double[]res=new double[6];
	    res[0]=phiMax-Math.pow(z, 0.5);
	    res[2]=phiMax+Math.pow(z, 0.5);
	    Kc=Util.lit_d(Kc_value.getText());
	    amont.getProperties();
//        double reducedFlow=massFlowRate/amont.P*amont.T/Kc/N;
//	    res[0]=res[0]*amont.P*Kc/amont.T/getFlow();
//	    res[1]=res[1]*amont.P*Kc/amont.T/getFlow();
	    res[3]=getPsi(res[0]);
	    res[4]=getPsi(phiMax);
	    res[5]=getPsi(res[2]);
	    res[0]=getFlow()/res[0]/amont.P/Kc*amont.T;
	    res[1]=getFlow()/phiMax/amont.P/Kc*amont.T;
	    res[2]=getFlow()/res[2]/amont.P/Kc*amont.T;
	    
	    return res;
	}
    
}