/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;


public class TechnoMoistAirEvaporator extends TechnoHx 
{
	double epsi=0.952;

	public TechnoMoistAirEvaporator()
	{
        super();
    }
	public TechnoMoistAirEvaporator(Projet proj, String hXname, PointThopt amontHot, PointThopt avalHot, PointThopt amontCold, PointThopt avalCold)
	{
	    super(proj, hXname, amontHot, avalHot, amontCold, avalCold);
	    corps=new CorpsThopt(proj, amontCold.nomCorps, amontCold.lecorps);
    }
	public TechnoMoistAirEvaporator(Projet proj, String hXname)
	{
	    super(proj, hXname);
	    corps=new CorpsThopt(proj, techf.amont.nomCorps, techf.amont.lecorps);
    }
  	public String getClassDescription(){
	    return "moist air evaporator class\n\nauthor : R. Gicquel  march 2018\n\nRef : archive ";
	}
	
    public String getType(){
        return "moist air evaporator";
    }
    public String getClassName(){
        return "TechnoMoistAirEvaporator";
    }
	
    public void makeDesign(){//chaud en sensible, froid diphasique (vaporateur)
    	//attention : le calcul de la surface d'change qui apparat dans l'cran techno demande  tre revu
    	//on fait l'hypothse que l'humidit relative de sortie vaut 0,951.
    	//on pourrait gnraliser en permettant des classes filles de changer cette valeur
    	//La corrlation  utiliser doit aussi tre modifie calcHX
        resetHX();
        Pfe=techf.amont.P;
        double Pfs=techf.aval.P;
        Tfl=corps.lecorps.getSatTemperature(Pfe,0);
        Tfv=corps.lecorps.getSatTemperature(Pfe,1);
	    corps.lecorps.CalcPropCorps(Tfl-0.1, Pfe, 0);
//	    System.out.println("corps "+corps.name+"  T "+Util.aff_d(Tfl-273.15)+"  Pfe "+Pfe);
	    corps.getSubstProperties();
	    corps.lecorps.CalcPropCorps(Tfl-0.1, Pfe, 0);
	    corps.getSubstProperties();
        double Hl=corps.H;
	    corps.lecorps.CalcPropCorps(Tfv+0.1, Pfe, 1);
	    corps.getSubstProperties();
        double Hv=corps.H;
 //       Tfl=Tfv-0.1;
        Lf=Hv-Hl;
        mCpflv=mf*Lf;   
/*        System.out.println("Tfl "+Tfl+"  Tfv "+Tfv+" corps.lecorps "+corps.name+" mCpflv "+mCpflv);
        System.out.println("Hl "+Hl+"  Hv "+Hv+" Tfl "+Tfl+" Tfv "+Tfv+" Pfe "+Pfe);
        
        //on estime les mCp liquide et vapeur indpendamment des tats des points amont et aval existants
	    corps.lecorps.CalcPropCorps(Tfv+10, Pfe, 1);
	    corps.getSubstProperties();
        mCpfv=mf*(corps.H-Hv)/10.;*/
	    corps.lecorps.CalcPropCorps(Tfs+2, Pfs, 1);//modRG 08/2009
	    corps.getSubstProperties();
        mCpfv=mf*(corps.H-techf.aval.H)/2.;
	    corps.lecorps.CalcPropCorps(Tfl-5, Pfe, 1);
	    corps.getSubstProperties();
        mCpfl=mf*(Hl-corps.H)/4.9;
        amontHot.getProperties();
//        System.out.println("amontHot W "+amontHot.W+"  epsi "+amontHot.Epsi+"  T "+amontHot.T);
        amontHot.update(false, false, false, false, true, "setW and calculate q'", amontHot.W);
        amontHot.getProperties();
//        System.out.println("amontHot q' "+amontHot.QPrime+"  epsi "+amontHot.Epsi+"  Tr "+amontHot.Tr);
        avalHot.getProperties();
//        System.out.println("avalHot W "+avalHot.W+"  epsi "+avalHot.Epsi+"  T "+avalHot.T);
        avalHot.update(false, false, false, false, true, "setW and calculate q'", avalHot.W);
        avalHot.getProperties();
//        System.out.println("avalHot q' "+avalHot.QPrime+"  epsi "+avalHot.Epsi+"  Tr "+avalHot.Tr);
        double deltaQprime=(amontHot.QPrime-avalHot.QPrime);
        double flow=techc.getFlow();
        double flow_as=flow/(1+amontHot.W);
        double mcpc=deltaQprime*flow_as/(amontHot.T-avalHot.T);
        System.out.println("deltaQprime "+deltaQprime+"  amontHot.QPrime "+amontHot.QPrime+"  avalHot.QPrime "+avalHot.QPrime);
        mCpc=mcpc;
        mCpclv=mCpc;        
        mCpcv=mCpc;
        mCpcl=mCpc;        
        
        if(techf.amont.X==0){//fluide froid liquide en entre
        
            if(false){//z_pinct==1){//pincement minimal
                Tcl=Tfv+DTmin;
                Tcv=Tcl+mCpflv/mCpc*(Tfv-Tfl);
                Tce=Tcv+mCpfv/mCpc*(Tfs-Tfv);
            }
            else if(true){//code_Tfs>0.7){//on suppose ici Tfs connu
                Tcv=Tce-mCpfv/mCpc*(Tfs-Tfv);
    //            Tcl=Tcv-mCpflv/mCpc*(Tfv-Tfl);
                Tcl=Tcv-mCpflv/mCpc;//modRG 08/2009
                Tcs=Tcl-mCpfl/mCpc*(Tfl-Tfe);
            }
            else if(false){//code_Tcs>0.7){//on suppose ici Tcs connu
                Tcl=Tcs+mCpfl/mCpc*(Tfv-Tfe);
                Tcv=Tcl+mCpflv/mCpc*(Tfv-Tfl);
                Tfs=Tfv+mCpc/mCpfv*(Tce-Tcv);
            }
            DTmin=Tcl-Tfv;
            //calcul des changeurs
            epsiv=(Tfs-Tfv)/(Tce-Tfv);
            if((epsiv>0)&&(epsiv<1)){
                Rv=mCpfv/mCpc;
                NUTv=Util.NUT_epsi(epsiv,Rv);
                UAv=mCpfv*NUTv;
            }
            else UAv=0;
            epsilv=(Tcv-Tcl)/(Tcv-Tfv);
            if((epsilv>0)&&(epsilv<1)){
                Rlv=mCpc/mCpflv;
                NUTlv=Util.NUT_epsi(epsilv,Rlv);
                UAlv=mCpc*NUTlv;
            }
            else UAlv=0;
            epsil=(Tfv-Tfe)/(Tce-Tfe);
            if((epsil>0)&&(epsil<1)){
                Rl=mCpfl/mCpc;
                NUTl=Util.NUT_epsi(epsil,Rl);
                UAl=mCpfl*NUTl;
            }
            else UAl=0;
        }
        else{//fluide froid diphasique en entre
            mCpflv=mf*Lf*(1.-techf.amont.X);
            if(false){//z_pinct==1){//pincement minimal
                Tcs=Tfv+DTmin;
                Tcv=Tcs+mCpflv/mCpc*(Tfv-Tfl);
            }
            else if(true){//code_Tfs>0.7){//on suppose ici Tfs connu (T sortie vaporateur)
            	//on calcule l'tat du gaz humide en sortie tel que l'changeur est quilibr sur le plan enthalpique
            	//en supposant DeltaH connu pour le frigorigne, la correction tant effectue au calcul suivant
            	double flowc=techf.getFlow();
            	double dQprimec=(avalCold.H-amontCold.H)*flowc/flow_as;//mCpfv*(Tfs-Tfv)/flow_as;
            	if(debug)System.out.println("dQprimec "+dQprimec+"  amontHot.QPrime "+amontHot.QPrime+"  amontCold.T "+amontCold.T+"  amontHot.T "+amontHot.T);
            	
            	Tcs=Util.dicho_T(this,amontHot.QPrime-dQprimec,0,"Tair",amontCold.T,amontHot.T,0.001);
            	//on calcule la temprature intermdiaire fictive 
            	Tcv=Tcs+mCpflv/mCpc;
        /*        Tcv=Tce-mCpfv/mCpc*(Tfs-Tfv);
                Tcs=Tcv-mCpflv/mCpc;//modRG 08/2009*/
                double x=0;
            }
            else if(false){//code_Tcs>0.7){//on suppose ici Tcs connu
                Tcv=Tcs+mCpflv/mCpc*(Tfv-Tfl);
                Tfs=Tfv+mCpc/mCpfv*(Tce-Tcv);
            }
            Tcl=Tcs;
            DTmin=Tcs-Tfv;
            //calcul des changeurs
            epsiv=(Tfs-Tfv)/(Tce-Tfv);
            Rv=mCpfv/mCpc;
            epsilv=(Tcv-Tcs)/(Tcv-Tfv);
            Rlv=mCpc/mCpflv;
            NUTv=Util.NUT_epsi(epsiv,Rv);
            UAv=mCpfv*NUTv;
            NUTlv=Util.NUT_epsi(epsilv,Rlv);
            UAlv=mCpc*NUTlv;
            UAl=0.;
        }
        
	    if(debug)System.out.println("epsiv "+epsiv+"  epsilv "+epsilv+"  epsil "+epsil);
	    if(debug)System.out.println("Rv "+Rv+"  Rlv "+Rlv+"  Rl "+Rl);
	    if(debug)System.out.println("mCpc "+mCpc+"  mCpflv "+mCpflv+"  mCpfv "+mCpfv);
	    if(debug)System.out.println("NUTv "+NUTv+"  NUTlv "+NUTlv+"  NUTl "+NUTl);
	    if(debug)System.out.println("UAv "+UAv+"  UAlv "+UAlv+"  UAl "+UAl);
	    if(debug)System.out.println("Tcv "+Tcv+"  Tcl "+Tcl+"  Tfv "+Tfv);
        UA=UAv+UAlv+UAl;
  //      UA_value.setValue(UA);
        Uv=getUv(techc.amont.X,1);
        Ul=getUl(techc.amont.X,0);
        Ulv=getUlv(techc.amont.X,0);
        setupA(true);
        calcPressureDrops(false);
        U=1000.*UA/A;
    }
    
    public double f_dicho(double T, double P, String fonc){
        
        if (fonc.equals("Tair"))return getqPrimeSat(T);
        
         
        return 0;
        
    }

    
	double getqPrimeSat(double T){
		avalHot.T=T;
		avalHot.update(true, false, false, false, true, "setEpsi and calculate", epsi);
		avalHot.getProperties();
		if(debug)System.out.println("aval.QPrime: " + avalHot.QPrime+" aval.Epsi: " + avalHot.Epsi+" aval.T: " + avalHot.T);
	    return avalHot.QPrime;
	}

    
}