/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;

import java.awt.*;

/**
 * Classe de dimensionnement technologique d'une turbine
 * Technological design class for turbines
 */

public class TechnoSimpleTurb extends ExtTechnoDesign implements optimization.Lmdif_fcn
{
	double Rd_global;
    String turbineName;
	double K1=0.87953221,	K2=0.0038, K3=-0.152, R1=7.0, R2=1.236;	
	double Kh=0.96, alpha=0.038, N=872.7969721981, Vs=0.0199;	
    int stageNumber=1;
	double PVR=0,PinCalc, flowCalc;
	
		// epsmch is the machine precision
	static final double epsmch = 2.22044604926e-16;
	boolean debug=false;

	int nfev = 0;
	int njev = 0;

	

	public TechnoSimpleTurb(){
	}

	public TechnoSimpleTurb(Projet proj, String turbineName, PointThopt amont, PointThopt aval){
		super(proj, turbineName, amont, aval);
	    this.turbineName=componentName;
	    setupPanel();
	}
	
	public TechnoSimpleTurb(Projet proj, String turbineName){
		super(proj, turbineName);
	    this.turbineName=componentName;
	    setupPanel();
	}

	void setupPanel(){
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,672,520);
		JLabel14.setText("isentropic efficiency");
        JPanel1.add(JLabel14);
		JLabel14.setBounds(372,144,144,24);
		risentr_value.setSelectionColor(new java.awt.Color(204,204,255));
		risentr_value.setSelectedTextColor(java.awt.Color.black);
		risentr_value.setCaretColor(java.awt.Color.black);
		risentr_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JPanel1.add(risentr_value);
		risentr_value.setBounds(516,144,120,24);
		displayLabel.setText("Expansion ratio");
		JPanel1.add(displayLabel);
		displayLabel.setBounds(372,216,132,24);
		m_value.setSelectionColor(new java.awt.Color(204,204,255));
		m_value.setSelectedTextColor(java.awt.Color.black);
		m_value.setCaretColor(java.awt.Color.black);
		m_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JPanel1.add(m_value);
		m_value.setBounds(516,180,120,24);
		JLabComprType.setText("Turbine type");
		JPanel1.add(JLabComprType);
		JLabComprType.setBounds(408,72,228,36);
		display_value.setSelectionColor(new java.awt.Color(204,204,255));
		display_value.setSelectedTextColor(java.awt.Color.black);
		display_value.setCaretColor(java.awt.Color.black);
		display_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JPanel1.add(display_value);
		display_value.setBounds(516,216,120,24);
		JLabel15.setText("flow rate");
		JLabel15.setBounds(new Rectangle(371, 182, 132, 24));
		JLabel1.setText("outlet area (m2)");
		JLabel1.setBounds(new Rectangle(1, 384, 144, 24));
		outletArea_value.setText("0.04");
		outletArea_value.setBounds(new Rectangle(145, 384, 120, 24));
		N_value.setText("1500");
		N_value.setBounds(new Rectangle(146, 307, 120, 24));
		JLabel5.setText("eta max");
		JLabel5.setBounds(new Rectangle(1, 94, 144, 24));
		etaMax_value.setText("0.9");
		etaMax_value.setBounds(new Rectangle(145, 94, 120, 24));
		JLabel7.setText("Stodola constant");
		JLabel7.setBounds(new Rectangle(0, 46, 108, 24));
		JLabel4.setText("eta lim");
		JLabel4.setBounds(new Rectangle(1, 118, 144, 24));
		etaLim_value.setText("0.8");
		etaLim_value.setBounds(new Rectangle(145, 118, 120, 24));
		JLabel8.setText("alpha Baumann");
		JLabel8.setBounds(new Rectangle(1, 260, 144, 24));
		alphaBaumann_value.setText("1");
		alphaBaumann_value.setBounds(new Rectangle(145, 260, 120, 24));
		JLabel9.setText("eta isentr");
		JLabel9.setBounds(new Rectangle(0, 207, 144, 24));
		etaIsentr_value.setText("0.9");
		etaIsentr_value.setBounds(new Rectangle(144, 207, 120, 24));
		Kh_value.setBounds(new Rectangle(144, 46, 120, 24));
		Kh_value.setText("0.96");
		JLabel6.setText("tau max");
		JLabel6.setBounds(new Rectangle(1, 142, 144, 24));
		tauMax_value.setText("5");
		tauMax_value.setBounds(new Rectangle(145, 142, 120, 24));
        JLabel2.setText("rotation speed");
        JCheckChoked.setLabel("choked turbine");
        JCheckChoked.setBounds(new Rectangle(0, 19, 158, 25));
        JCheckEtaIsConst.setLabel("eta isentr constant");
        JCheckEtaIsConst.setBounds(new Rectangle(0, 179, 158, 25));
        JCheckPVR.setLabel("residual velocity losses");
        JCheckPVR.setBounds(new Rectangle(1, 350, 158, 24));
		JLabel17.setText("beta ()");
		JLabel17.setBounds(new Rectangle(1, 410, 144, 24));
		beta_value.setText("30");
		beta_value.setBounds(new Rectangle(145, 410, 120, 24));
		JLabel16.setText("Diameter (m)");
		JLabel16.setBounds(new Rectangle(1, 440, 144, 24));
		D_value.setText("10");
		D_value.setBounds(new Rectangle(145, 440, 120, 24));
		JLabel19.setText("residual veloc. losses");
		JLabel19.setBounds(new Rectangle(1, 470, 144, 24));
		PVR_value.setText("10");
		PVR_value.setBounds(new Rectangle(145, 470, 120, 24));

        JPanel1.add(JLabel17);
        JPanel1.add(beta_value);
        JPanel1.add(JLabel16);
        JPanel1.add(D_value);
        JPanel1.add(JCheckPVR);
        JPanel1.add(JLabel15);
 //       JPanel1.add(etaIsentr_value);
 //       JPanel1.add(JLabel9);
        JPanel1.add(tauMax_value);
        JPanel1.add(JLabel5);
        JPanel1.add(etaMax_value);
        JPanel1.add(JLabel4);
        JPanel1.add(etaLim_value);
        JPanel1.add(JLabel6);
        JPanel1.add(JCheckChoked);
        JLabel2.setBounds(new Rectangle(2, 307, 144, 24));
        JPanel1.add(JLabel2);
        JPanel1.add(N_value);
        JPanel1.add(Kh_value);
        JPanel1.add(JLabel7);
 //       JPanel1.add(JCheckEtaIsConst);
  
        JPanel1.remove(JLabel8);
        JPanel1.remove(alphaBaumann_value);
        JPanel1.remove(outletArea_value);
        JPanel1.remove(JLabel1);
        JPanel1.remove(JLabel17);
        JPanel1.remove(beta_value);
        JPanel1.remove(JLabel16);
        JPanel1.remove(D_value);
        JPanel1.remove(JCheckPVR);
		JPanel1.remove(JLabComprType);
//		JPanel1.remove(displayLabel);
//		JPanel1.remove(display_value);
		stageNumber_value.setText("1");
	}



    public String getType(){
        return "TechnoSimpleTurb";
    }
	
    public String getClassName(){
        return "TechnoSimpleTurb";
    }
    public String getClassCode(){
        return "Expansion";
    }

	//{{DECLARE_CONTROLS
	javax.swing.JTextField risentr_value = new javax.swing.JTextField();
	javax.swing.JLabel displayLabel = new javax.swing.JLabel();
	javax.swing.JTextField m_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabComprType = new javax.swing.JLabel();
	javax.swing.JTextField display_value = new javax.swing.JTextField();
    javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel14 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel16 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel17 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel18 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel19 = new javax.swing.JLabel();
	javax.swing.JTextField PVR_value = new javax.swing.JTextField();
	javax.swing.JTextField outletArea_value = new javax.swing.JTextField();
	javax.swing.JTextField N_value = new javax.swing.JTextField();
	javax.swing.JTextField etaMax_value = new javax.swing.JTextField();
	javax.swing.JTextField etaLim_value = new javax.swing.JTextField();
	javax.swing.JTextField alphaBaumann_value = new javax.swing.JTextField();
	javax.swing.JTextField etaIsentr_value = new javax.swing.JTextField();
	javax.swing.JTextField Kh_value = new javax.swing.JTextField();
	javax.swing.JTextField D_value = new javax.swing.JTextField();
	javax.swing.JTextField beta_value = new javax.swing.JTextField();
	javax.swing.JTextField tauMax_value = new javax.swing.JTextField();
    javax.swing.JCheckBox JCheckChoked = new javax.swing.JCheckBox();
    javax.swing.JCheckBox JCheckEtaIsConst = new javax.swing.JCheckBox();
    javax.swing.JCheckBox JCheckPVR = new javax.swing.JCheckBox();
    javax.swing.JCheckBox JCheckMultiStage = new javax.swing.JCheckBox();
	javax.swing.JTextField stageNumber_value = new javax.swing.JTextField();
    //}}
    
	void setStageNumber(){
        stageNumber=Util.lit_i(stageNumber_value.getText());
	}

	void setStageNumber(int j){
        stageNumber=j;
        stageNumber_value.setText(Util.aff_i(j));
	}
    
  
    /*
    * Les mthodes ayant pour signature (double P) sont utilises par les algorithmes de recherche de solution
    * lorsque la pression amont de la turbine n'est pas connue
    * Lorsqu'elle l'est, la mthode sans signature est la bonne. Elle fait appel  amont.P
    */
    
    private double getZ(){
        return getZ(amont.P);
    }
    private double getZ(double P){
        stageNumber=Util.lit_i(stageNumber_value.getText());
        Rd_global=P/aval.P;
 //       System.out.println("Kh_classe turb: " + Kh+" Pin "+P);
       display_value.setText(Util.aff_d(Rd_global,2));
        double rd=Math.pow(Rd_global,1./stageNumber);
        double z=1;
        double k_poly=getPolytropicCoefficient();//1.3;
        double kk=(k_poly+1.)/k_poly;
        if(JCheckChoked.isSelected()){//pas d'influence de l'aval
            z=P*P/amont.T;
        }
        else{
            z=P*P/amont.T*(1.-Math.pow(1./rd,kk));
        }
        return z;
    }

    private double getZ(double Pin, double Pout){//deprecated
        double z=1;
        stageNumber=Util.lit_i(stageNumber_value.getText());
        Rd_global=Pin/Pout;
        display_value.setText(Util.aff_d(Rd_global,2));
        double rd=Math.pow(Rd_global,1./stageNumber);
        
        
        double k_poly=getPolytropicCoefficient();//1.3;
        double kk=(k_poly+1.)/k_poly;
        if(JCheckChoked.isSelected()){//pas d'influence de l'aval
            z=Pin*Pin/amont.T;
        }
        else{
            z=Pin*Pin/amont.T*(1.-Math.pow(1./rd,kk));
        }
        return z;
    }
    public double getKh(){
        return Kh;
    }
    public void setKh(double K){
        Kh=K;
        Kh_value.setText(Util.aff_d(Kh,4));
    }
    
    /**
    * calcule et renvoie la constante de Stodola
    *<p>
    * returns the Stodola constant
    **/
    public double getStodolaConstant(){
        Kh=getFlow()/Math.pow(getZ(), 0.5);//rgle de Stodola
        Kh_value.setText(Util.aff_d(Kh,4));
        return Kh;
    }
  
    /**
    * calcule et renvoie la constante de Stodola
    *<p>
    * returns the Stodola constant
    * @param flow (flow rate)
    **/
    public double getStodolaConstant(double flow){
        double K=flow/Math.pow(getZ(), 0.5);//rgle de Stodola
        return K;
    }
    
    /**
    * calcule et renvoie le dbit massique
    *<p>
    * returns the mass flow
    **/
    public double getMassFlow(){
        double massFlow=Kh*Math.pow(getZ(), 0.5);
	    m_value.setText(Util.aff_d(massFlow,4));
        return massFlow;
    }
    /**
    * calcule et renvoie le dbit massique
    *<p>
    * returns the mass flow
    * @param Pin (pressure in bar)
    **/
    public double getMassFlow(double Pin){
        double massFlow=Kh*Math.pow(getZ(Pin), 0.5);
        
	    m_value.setText(Util.aff_d(massFlow,4));
        return massFlow;
    }
    /**
    * calcule et renvoie le dbit massique
    *<p>
    * returns the mass flow
    * @param Pin (pressure in bar)
    * @param Pout (pressure in bar)
    **/
    public double getMassFlow(double Pin, double Pout){
        double massFlow=Kh*Math.pow(getZ(Pin, Pout), 0.5);
	    m_value.setText(Util.aff_d(massFlow,4));
        return massFlow;
    }
    
    /**
    * calcule et renvoie la pression d'entre correspondant au dbit
    * (inversion en P de la caractristique turbine connaissant le dbit)
    *<p>
    * returns the inlet pressure corresponding to the flow rate
    * @param flow (flow rate)
    **/
    public double getTurbineInletPressure(double flow){
        if(flow==0)return aval.P;
        else{
            flowCalc=flow;
            double P=0.;
        //    double 
            PinCalc=2.*aval.P;
            
		    int m = 1;
		    int n = 1;
    	        
		    double fvec[] = new double[m+1];
		    double x[] = new double[n+1];
    	    int info[] = new int[2];
		    int iflag[] = new int[2];
    	        
		    x[1] = PinCalc;
    		
		    double residu0;
		    double residu1;
    	        
            fcn(m,n,x,fvec,iflag);
		    residu0 = optimization.Minpack_f77.enorm_f77(m,fvec);
		    double epsi=0.00001;//prcision globale demande sur la convergence
            double epsfcn = 1.e-8;//prcision calcul des diffrences finies
            //appel modifi de lmdiff avec modification prcision calcul des diffrences finies
		    optimization.Minpack_f77.lmdif2_f77(this, m, n, x, fvec, epsi, epsfcn, info);
		    residu1 = optimization.Minpack_f77.enorm_f77(m,fvec);
    		
    		if(debug){
		        System.out.println(); 
		        System.out.println(" Initial L2 norm of the residuals: " + residu0); 
                System.out.println("Final L2 norm of the residuals: " + residu1);
                System.out.println("Number of function evaluations: " + nfev);
                System.out.println("Number of Jacobian evaluations: " + njev);
                System.out.println("Info value: " + info[1]);
                System.out.println("Final approximate solution: " + x[1]  );
		        System.out.println(); 
		    }
	        return PinCalc;
	    }
    }
    
 	public void fcn(int m, int n, double x[], double fvec[], int iflag[]) {
		
		if (iflag[1]==1) this.nfev++;
		if (iflag[1]==2) this.njev++;
		
		//mise  jour de la variable "physique" pour une meilleure comprhension du code
        PinCalc=x[1];
        //calcul du rsidu
		fvec[1] = resFlow();
    }
    
    double resFlow(){
        double res=0;
        double y=getMassFlow(PinCalc);
        res=2.*(flowCalc-y)/(flowCalc+y);
//        System.out.println("PinCalc: " + PinCalc +"resFlow: "+res );
        return res;
    }
    
    /**
    * renvoie le rendement isentropique sec
    *<p>
    * returns the dry isentropic efficiency
    **/
   public double getRisentr(){
	    double etaMax=Util.lit_d(etaMax_value.getText());
	    double etaLim=Util.lit_d(etaLim_value.getText());
	    double tauMax=Util.lit_d(tauMax_value.getText());
	    
	    K1=etaLim;
	    K2=2*tauMax*(etaMax-etaLim);//modRG 2018
        K3=-tauMax*tauMax*(etaMax-etaLim);
        
	    Rd_global=amont.P/aval.P;
        double rd=Math.pow(Rd_global,1./stageNumber);
	    
	    double risentr= K1+K2/rd+K3/rd/rd;
//        System.out.println("Rd_global: " + Rd_global + ", K1 "+ K1 + ", K2 " + K2+ ", K3 " + K3);

	    risentr_value.setText(Util.aff_d(risentr,4));
	    return risentr;
    }


	public void makeDesign(){
	    double K=getStodolaConstant();
	    setKh(K);
	    Rd_global=amont.P/aval.P;
	    double r_isentr=getRisentr();
	    risentr_value.setText(Util.aff_d(r_isentr,4));
	    double val=getFlow();
	    m_value.setText(Util.aff_d(val,4));
	}

    //on ne relit pas certains paramtres, qui n'intressent que les classes filles
	public void readCompParameters(String ligne_data){
        String valeur;
        valeur=Util.extr_value(ligne_data, "N_value");
        if(valeur!=null)N_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "etaMax_value");
        if(valeur!=null)etaMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "etaLim_value");
        if(valeur!=null)etaLim_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "etaIsentr_value");
        if(valeur!=null)etaIsentr_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "Kh_value");
        if(valeur!=null)setKh(Util.lit_d(valeur));
        valeur=Util.extr_value(ligne_data, "tauMax_value");
        if(valeur!=null)tauMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "isChoked");
        if(valeur!=null)JCheckChoked.setSelected(Util.lit_b(valeur));
        valeur=Util.extr_value(ligne_data, "isEtaConst");
        if(valeur!=null)JCheckEtaIsConst.setSelected(Util.lit_b(valeur));
	}


	/**
	 * saves project file specific technoDesign data	 
	 */
    //on sauve tous les paramtres, mme ceux qui n'intressent que les classes filles
    public String saveCompParameters(){
	    String h="outletArea_value="+outletArea_value.getText()+tab
	    +"N_value="+N_value.getText()+tab
	    +"etaMax_value="+etaMax_value.getText()+tab
	    +"etaLim_value="+etaLim_value.getText()+tab
	    +"alphaBaumann_value="+alphaBaumann_value.getText()+tab
	    +"etaIsentr_value="+etaIsentr_value.getText()+tab
	    +"Kh_value="+Kh_value.getText()+tab
	    +"tauMax_value="+tauMax_value.getText()+tab
	    +"beta_value="+beta_value.getText()+tab
	    +"D_value="+D_value.getText()+tab
	    +"stageNumber_value="+stageNumber_value.getText()+tab
	    +"isChoked="+Util.aff_b(JCheckChoked.isSelected())+tab
	    +"isEtaConst="+Util.aff_b(JCheckEtaIsConst.isSelected())+tab
	    +"isPVR="+Util.aff_b(JCheckPVR.isSelected())+tab
	    

	    +"\n";//retour  la ligne impratif
        return h;
    }	
}
 