/*
Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.util.*;

import javax.swing.*;

import rg.thopt.*;

/**
 * Classe de dimensionnement technologique pour un changeur coupl  un thermocoupleur
 * 
 * @author Renaud GICQUEL
 */
public class TechnoTC extends ExtTechnoDesign implements Inversable
{
	public TechnoExch tech;
    public String config_f,config_c, hXname, exchFluid;//, coldFluid;
	double Tf,Tc,lambda_f,mu_f,lambda_c,mu_c;
	public double UA;
	double Pr_f,Pr_c,Re_f,Re_c,Nu_f,Nu_c, Gc,Gf,dPc,dPf,hc,hf;
    double Tci,Tfi,mCpc1,mCpc2,epsi1,R1,UA1,NUT1,epsi2,R2,UA2,NUT2,corpscX,corpsfX;
	boolean debug=true,isThreeStep=false, makesDesign=false;
    PointThopt amontExch,avalExch;
	
    double Tl,Tv,Pe,Ps,Xe,Xs,L,DTmin,U,A,
    mCpl,epsil,Rl,UAl,NUTl,Ul,Al,DTMLl,DTMLlv,DTMLv,
    mCpv,epsiv,Rv,UAv,NUTv,Uv,Av,
    mCplv,epsilv,Rlv,UAlv,NUTlv,Ulv,Alv;
    double mCp,$test,Sigma_code,Te,Ts,m;
    double Cp,$Tce,$Tcs,$Tfe,$Tfs,epsilon,DHc,DHf;
    
    protected int z_pinct,z_libre,z_effic,$Icas,$sigma;
    protected double code_Tce,code_Tcs,code_Tfe,code_Tfs,code_mc,code_mf;
    
    public ThermoCouplerProcess hC;
    
//    CorpsThopt corps;
	
	
	JPanel techPanc,techPanf;
	Projet proj;
	
	public TechnoTC(){
	}
	

	public TechnoTC(Projet proj, String hXname, PointThopt amontExch, PointThopt avalExch, ThermoCouplerProcess hC)
	{
		this();
		this.proj=proj;
		this.hC=hC;
		this.hXname=hXname;
		componentName=hXname;
        String[] args=new String[2];
        args[0]="heatEx";
        args[1]=hXname;
        Vector vProp=proj.getProperties(args);
        if(vProp.size()==0){
	        String msg = "Watch out!: heat exchanger "+hXname+" does not exist in the project";
	        JOptionPane.showMessageDialog(tde, msg);  
        }else{
            exchFluid=(String)vProp.elementAt(0);  
            String secondFluid=(String)vProp.elementAt(1);
//            System.out.println("exchFluid " +exchFluid + " secondFluid "+secondFluid );
            this.amontExch=amontExch;
            this.avalExch=avalExch; 
            
            tech=new TechnoExch(proj, this, exchFluid, amontExch, avalExch);
            
    //        tech.setOtherTechnoExch();
    		
		    JLabCompName.setText(hXname);
	        exchName.setText(exchFluid);
    //	    coldName.setText(coldFluid);
	        setupPanel();
            setupTechHx();
        }
	}
	public TechnoTC(Projet proj, String hXname, ThermoCouplerProcess hC)
	{
		this();
		this.proj=proj;
		this.hC=hC;
		this.hXname=hXname;
		componentName=hXname;
        String[] args=new String[2];
        args[0]="heatEx";
        args[1]=hXname;
        Vector vProp=proj.getProperties(args);
        exchFluid=(String)vProp.elementAt(0);  
        
        tech=new TechnoExch(proj, this, exchFluid);
        this.amontExch=tech.amont;
        this.avalExch=tech.aval; 
        
		JLabCompName.setText(hXname);
	    exchName.setText(exchFluid);
	    setupPanel();
        setupTechHx();
	}
	
	
	void setupPanel(){
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,800,500);
		JLabhlc.setText("hl");
		JPanel1.add(JLabhlc);
		JLabhlc.setForeground(java.awt.Color.red);
		JLabhlc.setBounds(10,50,180,24);
		JLabhlf.setText("hlf");
//		JPanel1.add(JLabhlf);
		JLabhlf.setForeground(java.awt.Color.blue);
		JLabhlf.setBounds(10,132,180,24);
		JLabhlvc.setText("hlv");
		JPanel1.add(JLabhlvc);
		JLabhlvc.setForeground(java.awt.Color.red);
		JLabhlvc.setBounds(10,74,180,24);
		JLabhlvf.setText("hlvf");
//		JPanel1.add(JLabhlvf);
		JLabhlvf.setForeground(java.awt.Color.blue);
		JLabhlvf.setBounds(10,156,180,24);
		JLabhvf.setText("hvf");
	//	JPanel1.add(JLabhvf);
		JLabhvf.setForeground(java.awt.Color.blue);
		JLabhvf.setBounds(10,180,180,24);
		JLabhvc.setText("hv");
		JPanel1.add(JLabhvc);
		JLabhvc.setForeground(java.awt.Color.red);
		JLabhvc.setBounds(10,98,180,24);
	/*	JPanel2.setLayout(null);
		JPanel1.add(JPanel2);
		JPanel2.setBounds(12,320,708,196);
		JLabel6.setText("Hx area");
		JPanel2.add(JLabel6);
		JLabel6.setForeground(new java.awt.Color(102,102,153));
		JLabel6.setBounds(444,108,96,24);
		JPanel2.add(A_value);
		A_value.setBounds(588,108,104,24);
		JLabel11.setText("UA1");
		JPanel2.add(JLabel11);
		JLabel11.setBounds(12,84,96,24);
		JPanel2.add(UA1_value);
		UA1_value.setBounds(144,84,104,24);
		JLabel12.setText("UA2");
		JPanel2.add(JLabel12);
		JLabel12.setBounds(12,108,96,24);
		JPanel2.add(UA2_value);
		UA2_value.setBounds(144,108,104,24);
		JLabUl.setText("Ul");
		JPanel2.add(JLabUl);
		JLabUl.setForeground(new java.awt.Color(102,102,153));
		JLabUl.setBounds(300,0,96,24);
		JLabUlv.setText("Ulv");
		JPanel2.add(JLabUlv);
		JLabUlv.setForeground(new java.awt.Color(102,102,153));
		JLabUlv.setBounds(300,24,96,24);
		JLabUv.setText("Uv");
		JPanel2.add(JLabUv);
		JLabUv.setForeground(new java.awt.Color(102,102,153));
		JLabUv.setBounds(300,48,96,24);
		JLabAv.setText("Av");
		JPanel2.add(JLabAv);
		JLabAv.setForeground(new java.awt.Color(102,102,153));
		JLabAv.setBounds(432,48,96,24);
		JLabAl.setText("Al");
		JPanel2.add(JLabAl);
		JLabAl.setForeground(new java.awt.Color(102,102,153));
		JLabAl.setBounds(432,0,96,24);
		JLabAlv.setText("Alv");
		JPanel2.add(JLabAlv);
		JLabAlv.setForeground(new java.awt.Color(102,102,153));
		JLabAlv.setBounds(432,24,96,24);
		JLabel15.setText("DT step");
		JPanel2.add(JLabel15);
		JLabel15.setBounds(12,36,96,24);
		DTstep_value.setText("2.5");
		JPanel2.add(DTstep_value);
		DTstep_value.setBounds(144,36,104,24);*/
		JLabel3.setText("e/\u03BB");//e/lambda
		JPanel1.add(JLabel3);
		JLabel3.setBounds(450,96,96,24);
		JPanel1.add(eLambda_value);
		eLambda_value.setText("0");
		eLambda_value.setBounds(550,96,104,24);
		JLabel4.setText("Hx design area");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(450,130,96,24);
		JPanel1.add(ADesign_value);
		ADesign_value.setBounds(550,130,104,24);
		JLabel5.setText("average U");
//		JPanel1.add(JLabel5);
		JLabel5.setBounds(450,164,96,24);
//		JPanel1.add(U_value);
		U_value.setBounds(550,164,104,24);
	//	JPanel3.setLayout(null);
	//	JPanel1.add(JPanel3);
	//	JPanel3.setBounds(0,0,516,330);
		JPanel1.add(exchName);
		exchName.setForeground(java.awt.Color.red);
		exchName.setBounds(60,150,215,17);
		JPanel1.add(coldName);
		coldName.setBounds(60,406,215,17);
	}
	
	public void setupTechHx(){
	    techPanc=tech.JPanel1;
	    JPanel1.add(techPanc);
	    techPanc.setBounds(0, 70, 804,245);
	}
	
	public String getNom(){
	    return "TechnoTC";
	}
	public String getClassType(){
	    return "TechnoTC";
	}

    public String getClassCode(){
        return "ThermoCoupler";
    }
    
        public String getClassName(){
        return "TechnoTC";
    }


    public String getType(){
        return "basic thermocoupler";
    }
    
  	public String getClassDescription(){
	    return "TechnoTC\n\nauthor : R. Gicquel  november 2008\n\nRef : archive ";
	}


	//{{DECLARE_CONTROLS
	javax.swing.JLabel JLabhlc = new javax.swing.JLabel();
	javax.swing.JLabel JLabhlf = new javax.swing.JLabel();
	javax.swing.JLabel JLabhlvc = new javax.swing.JLabel();
	javax.swing.JLabel JLabhlvf = new javax.swing.JLabel();
	javax.swing.JLabel JLabhvf = new javax.swing.JLabel();
	javax.swing.JLabel JLabhvc = new javax.swing.JLabel();
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField U_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField A_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JTextField UA1_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JTextField UA2_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabUl = new javax.swing.JLabel();
	javax.swing.JLabel JLabUlv = new javax.swing.JLabel();
	javax.swing.JLabel JLabUv = new javax.swing.JLabel();
	javax.swing.JLabel JLabAv = new javax.swing.JLabel();
	javax.swing.JLabel JLabAl = new javax.swing.JLabel();
	javax.swing.JLabel JLabAlv = new javax.swing.JLabel();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JTextField DTstep_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField eLambda_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	public javax.swing.JTextField ADesign_value = new javax.swing.JTextField();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JLabel exchName = new javax.swing.JLabel();
	javax.swing.JLabel coldName = new javax.swing.JLabel();
	javax.swing.JLabel JLabCompName = new javax.swing.JLabel();
	//}}

	//{{DECLARE_MENUS
	//}}

/**
* updates the heat exchanger Cp, mCp, Te and Ts
*
**/
	public void resetHX(){
		tech.updateDeltaH();
		if(tech.DeltaH<0){//rouge
		    JLabhlc.setForeground(java.awt.Color.red);
		    JLabhlvc.setForeground(java.awt.Color.red);
		    JLabhvc.setForeground(java.awt.Color.red);
		    exchName.setForeground(java.awt.Color.red);
		}else{
		    JLabhlc.setForeground(java.awt.Color.blue);
		    JLabhlvc.setForeground(java.awt.Color.blue);
		    JLabhvc.setForeground(java.awt.Color.blue);
		    exchName.setForeground(java.awt.Color.blue);
		}
        if(tech.amont.T!=tech.aval.T){
            Cp=Math.abs(tech.DeltaH/(tech.amont.T-tech.aval.T));
            Ts=tech.aval.T;
        }
        else{ //vaporization or condensation
            Cp=Math.abs(tech.DeltaH/0.1);
            if(tech.DeltaH>0)Ts=tech.aval.T-0.1;
            else Ts=tech.aval.T+0.1;
        }
        m=tech.getFlow();
        mCp=Cp*m;
        Te=tech.amont.T;
    }
    

    //Calculs des U
    public double getUv(double xc,double xf){
        double u=1;
        if((tech!=null)){
        //    calcNusselt((Tce+Tcv)/2., (Tfs+Tfv)/2., Pce, Pfe, xc, xf, mCpcv/mc, mCpfv/mf, false,false);
            tech.calcNusselt((Ts+Tv)/2., tech.amont.P, xc, mCpv/m, false,false);
            u=get_U();
            JLabhvc.setText("hv = "+Util.aff_d(hc,2)+" Re = "+Util.aff_d(tech.Re,2));
        }
        return u;
    }

    public double getUl(double xc,double xf){
        double u=1;
        if((tech!=null)){
        //    calcNusselt((Tcl+Tcs)/2., (Tfl+Tfe)/2., Pce,Pfe, xc, xf, mCpcl/mc, mCpfl/mf, false,false);
            tech.calcNusselt((Tv+Te)/2., tech.amont.P, xc, mCpl/m, false,false);
            u=get_U();
            JLabhlc.setText("hl = "+Util.aff_d(hc,2)+" Re = "+Util.aff_d(tech.Re,2));
        }
        return u;
    }

    public double getUlv(double xc,double xf){
        double u=1;
        if((tech!=null)){
            tech.calcNusselt(Tv, tech.amont.P, tech.amont.X, mCpl/m, false,true);
            u=get_U();
            JLabhlvc.setText("hlv = "+Util.aff_d(hc,2)+" Re = "+Util.aff_d(tech.Re,2));
        }
        return u;
    }
    public void setupA(boolean changesA){//calcule le A global et met  jour le TechnoTC
    	System.out.println("TechnoTC Uv "+Uv+"  Ulv "+Ulv+"  Ul "+Ul);
        Av=1000.*UAv/Uv;
        Al=1000.*UAl/Ul;
        Alv=1000.*UAlv/Ulv;
        A=Av+Alv+Al;
        setupA(changesA,A,Ul,Al,Ulv,Alv,Uv,Av);
    }
    	
	public void calcNUsselt(){// calcul de base pour un changeur en sensible (non 3 steps)
	    tech.calcNUsselt();
	}

	public void makeDesign(){
	    resetHX();
	    makesDesign=true;
	    tech.calcNUsselt();
	    if(tech.mu*tech.lambda!=0){
            double fin_c=Util.lit_d(tech.FA_value.getText())*Util.lit_d(tech.etaF_value.getText());
            double Nuc=tech.Nu;
            double hc=tech.lambda*tech.Nu*fin_c/Util.lit_d(tech.Dh_value.getText());
            JLabhvc.setText("hc = "+Util.aff_d(hc,2)+"  Re = "+Util.aff_d(tech.getRe(),2));
	        hf=hC.getU();
	        displayU();

//	            U=1./(tech.Dh_value.getValue()/tech.lambda/tech.Nu/fin_c+techf.Dh_value.getValue()/techf.lambda/techf.Nu/fin_f);
	        U=1./(1./hc+Util.lit_d(eLambda_value.getText())+1/hf);
	        U_value.setText(Util.aff_d(U,4));
	        double A=UA/U*1000.;//UA en kW/K
	        ADesign_value.setText(Util.aff_d(A,4));
	        A_value.setText(Util.aff_d(A));
	    }
	    calcPressureDrops(false);
	    makesDesign=false;
	}
	public void displayU(){
		U_value.setVisible(true);
	    U_value.setText(Util.aff_d(U,4));
		JLabel5.setText("average U");
//		JPanel1.repaint();
	}

    public void calcPressureDrops(boolean calcNusselt){
        tech.calcPressureDrop(calcNusselt);
    }
	
	public double getU(){
	    return U;
	}

	public double getA(){
	    return A;
	}
	
	public double getAl(){
	    return Al;
	}
	
	public double getAlv(){
	    return Alv;
	}
	
	public double getAv(){
	    return Av;
	}
	

	public double get_U(){//calcul de U avec prise en compte des facteurs d'amplification de surface ( creuser)
	    if(tech.mu*tech.lambda!=0){
	    	tech.calcH();
	        hc=tech.getH();
	        hf=hC.getU();

            double fin_c=Util.lit_d(tech.FA_value.getText())*Util.lit_d(tech.etaF_value.getText());
    	            
	        System.out.println("hc "+hc+"  hf "+hf+"  tech.lambda "+tech.lambda+"  tech.mu "+tech.mu);
	        return 1/(1/fin_c/hc+Util.lit_d(eLambda_value.getText())+1/hf);
	    }
	    return 1.;
	}
	
    public void setupA(boolean changesA, double A, double Ul, double Al, double Ulv, double Alv, double Uv, double Av){
        //met  jour l'cran du TechnoTC et crit dans output.txt
        JLabUl.setText("Ul = "+Util.aff_d(Ul,2));
        JLabUlv.setText("Ulv = "+Util.aff_d(Ulv,2));
        JLabUv.setText("Uv = "+Util.aff_d(Uv,2));
        JLabAl.setText("Al = "+Util.aff_d(Al,2));
        JLabAlv.setText("Alv = "+Util.aff_d(Alv,2));
        JLabAv.setText("Av = "+Util.aff_d(Av,2));
        if(changesA)ADesign_value.setText(Util.aff_d(A,5));
        
        if(debug)System.out.println("");
        if(debug)System.out.println("changeur "+hXname);
        if(debug)System.out.println("Ul : "+Ul+"  Ulv : "+Ulv+"  Uv : "+Uv);
        if(debug)System.out.println("Al : "+Al+"  Alv : "+Alv+"  Av : "+Av);
        if(debug)System.out.println("");
    }

    public void calcHx(){
  	    if(tech.mu*tech.lambda!=0){
	        //On commence par valuer U  partir des TechnoExch chaud et froid
	        U=1./(Util.lit_d(tech.Dh_value.getText())/tech.lambda/tech.Nu+
	        Util.lit_d(eLambda_value.getText()));
	        U_value.setText(Util.aff_d(U));
	        if(Util.lit_d(A_value.getText())!=0){
	            UA=U*Util.lit_d(A_value.getText())/1000.;//UA en kW/K
	        }
	        else{
	            String msg = "Watch out!: the heat exchanger area equals 0.";
	//modRG            JOptionPane.showMessageDialog(tde, msg);  
	        }
	    }
  }

	public void Calculate(){
        UA1_value.setText(Util.aff_d(0.));
        UA2_value.setText(Util.aff_d(0.));
	    calcNUsselt();//modRG 13_05
	    calcHx();
	}
	
/**
* generic inversion function called by Util.dicho_T
 * fonction gnrique appele par Util.dicho_T
 * @return double
 * @param $T double (temprature)
 * @param $p double (pression)
 * @param $fonct java.lang.String (code de  la fonction appele)
 */
public double f_dicho(double $T,double $p, String $fonct) {
 //   double reste=0;
    if ($fonct.equals("cas1")){
        return UA-UA1-UA2;
    }
    else if ($fonct.equals("cas2")){
        return UA-UA1-UA2;
    }
    else{
    	//modRG	    JOptionPane.showMessageDialog(tde,"function in f_dicho TechnoTC does not exist: "+$fonct);
        return 0;
    }
}

	/**
	 * reads project file specific technoDesign data
	 */
	public void readCaract(String ligne_data){
//	    super.readCaract(ligne_data);
        String value=Util.extr_value2(ligne_data, "3steps");
	    if(!(value==null))isThreeStep=Util.lit_b(value);
//        setupTechHx();
        value=Util.extr_value2(ligne_data, "ADesign_value");
		if(!(value==null))ADesign_value.setText(value);
		tech.readCaract(Util.extr_value4(ligne_data,"confHot"));
//		techf.readCaract(Util.extr_value4(ligne_data,"confCold"));
	    
	}
	
	public void readCompParameters(String ligne_data){
		StringTokenizer st= new StringTokenizer(ligne_data,"\n");
	    String ligne = st.nextToken();
        String value=Util.extr_value(ligne, "ADesign_value");
		if(!(value==null))ADesign_value.setText(value);
		value=Util.extr_value(ligne, "eLambda");
		if(!(value==null))eLambda_value.setText(value);
		ligne = st.nextToken();
		tech.readCompParameters(ligne);	    
	}
	
	
	

	/**
	 * saves project file specific technoDesign data
	 */
    public String saveCaract(){
	    String h="3steps="+Util.aff_b(isThreeStep)+":"
        +"ADesign_value="+ADesign_value.getText()+":"
        +"@confHot="+tech.saveCaract()+":"
//        +"@confCold="+techf.saveCaract()+":"
        ;
        
        return h;
    }
    public String saveCompParameters(){
	    String h="ADesign_value="+ADesign_value.getText()+"\teLambda="+eLambda_value.getText()+"\n"
        +tech.saveCompParameters()+"\n"
//        +techf.saveCompParameters()+"\n"//retour  la ligne impratif (les deux prcdents sont spcifiques des changeurs)
        ;
        
        return h;
    }
    
	
}