/*
Copyright Renaud GICQUEL 2005-2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.thopt.*;
import java.awt.*;

/**
 * Classe de dimensionnement technologique d'un compresseur volumtrique
 * Technological design class for volumetric compressors
 */

public class TechnoTurboCompr extends ExtTechnoDesign
{
	double r_compr;
    String compressorName;
	double K1=0.87953221,	K2=0.0038, K3=-0.152, R1=7.0, R2=1.236;	
	double Kc, alpha=0.038, N=872.7969721981, Vs=0.0199;	
    int stageNumber=1;
	
	TurboComprMapDataFrame tcf;
	

	public TechnoTurboCompr(){
	}

	public TechnoTurboCompr(Projet proj, String compressorName, PointThopt amont, PointThopt aval){
		super(proj, compressorName, amont, aval);
	    this.compressorName=componentName;
	    setupPanel();
	}
	public TechnoTurboCompr(Projet proj, String compressorName){
		super(proj, compressorName);
	    this.compressorName=componentName;
	    setupPanel();
	}
    void setupPanel(){
		JPanel1.setLayout(null);
		JPanel1.setBounds(new Rectangle(0, 0, 658, 520));
		JLabel14.setText("isentropic efficiency");
		JLabel14.setBounds(372,144,144,24);
		risentr_value.setSelectionColor(new java.awt.Color(204,204,255));
		risentr_value.setSelectedTextColor(java.awt.Color.black);
		risentr_value.setCaretColor(java.awt.Color.black);
		risentr_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		Kc_value.setText("");
        psiCoeff_value.setText("-20");
        psiMax_value.setText("20");
        JPanel1.add(JLabel14);
        JPanel1.add(risentr_value);
        JPanel1.add(JLabComprType);
        JPanel1.add(JLabel12);
        JPanel1.add(Kc_value);
        JPanel1.add(JLabel15);
        JPanel1.add(D_value);
        JPanel1.add(JLabel2);
        JPanel1.add(etaMax_value);
        JPanel1.add(JLabel5);
        JPanel1.add(JLabel6);
        JPanel1.add(etaCoeff_value);
        JPanel1.add(JLabel4);
        JPanel1.add(phiEtaMax_value);
        JPanel1.add(JLabel7);
        JPanel1.add(mc_value);
        JPanel1.add(m_value);
        JPanel1.add(phiPsiMax_value);
        JPanel1.add(JLabel3);
        JPanel1.add(psiMax_value);
        JPanel1.add(JLabel1);
        JPanel1.add(psiCoeff_value);
        JPanel1.add(JLabel9);
		risentr_value.setBounds(516,144,120,24);
		m_value.setSelectionColor(new java.awt.Color(204,204,255));
		m_value.setSelectedTextColor(java.awt.Color.black);
		m_value.setCaretColor(java.awt.Color.black);
		m_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		m_value.setBounds(new Rectangle(514, 218, 120, 24));
		JLabComprType.setText("Compressor type");
		JLabComprType.setBounds(408,72,228,36);
		mc_value.setSelectionColor(new java.awt.Color(204,204,255));
		mc_value.setSelectedTextColor(java.awt.Color.black);
		mc_value.setCaretColor(java.awt.Color.black);
		mc_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		mc_value.setBounds(new Rectangle(515, 182, 120, 24));
		JLabel15.setText("flow rate");
		JLabel15.setBounds(new Rectangle(372, 212, 132, 24));
		JLabel1.setText("psi coefficient");
		JLabel1.setBounds(new Rectangle(1, 149, 144, 24));
		psiCoeff_value.setBounds(new Rectangle(145, 149, 120, 24));
		D_value.setText("1500");
		D_value.setBounds(new Rectangle(146, 66, 120, 24));
		JLabel12.setText("reduced flow Rate");
		JLabel12.setBounds(372,180,144,24);
		JLabel3.setText("psi Max");
		JLabel3.setBounds(new Rectangle(0, 122, 132, 24));
		psiMax_value.setBounds(new Rectangle(144, 122, 120, 24));
		JLabel5.setText("eta max");
		JLabel5.setBounds(new Rectangle(4, 237, 144, 24));
		etaMax_value.setText("0.85");
		etaMax_value.setBounds(new Rectangle(148, 237, 120, 24));
		JLabel7.setText("Kc");
		JLabel7.setBounds(new Rectangle(3, 30, 108, 24));
		JLabel4.setText("phi eta max");
		JLabel4.setBounds(new Rectangle(5, 297, 144, 24));
		phiEtaMax_value.setText("0.3");
		phiEtaMax_value.setBounds(new Rectangle(149, 297, 120, 24));
		JLabel9.setText("phi psi max");
		JLabel9.setBounds(new Rectangle(2, 177, 144, 24));
		phiPsiMax_value.setText("0.08");
		phiPsiMax_value.setBounds(new Rectangle(146, 177, 120, 24));
		Kc_value.setBounds(144,30,120,24);
		JLabel6.setText("eta coefficient");
		JLabel6.setBounds(new Rectangle(4, 266, 144, 24));
		etaCoeff_value.setText("-10");
		etaCoeff_value.setBounds(new Rectangle(148, 266, 120, 24));
		JLabel2.setText("diameter");
		JLabel2.setBounds(new Rectangle(2, 66, 144, 24));
		stageNumber_value.setText("1");
		JLabel7.setText("Kc");
        JPanel1.add(N_value);
        JPanel1.add(JLabel10);
		JLabel10.setText("N");
		JLabel10.setBounds(new Rectangle(2, 207, 144, 24));
		N_value.setText("20000");
		N_value.setBounds(new Rectangle(146, 207, 120, 24));

		JPanel1.remove(JLabComprType);
		
        JPanel1.remove(N_value);
        JPanel1.remove(JLabel10);
		
	}

    public String getType(){
        return "TechnoTurboCompr";
    }
	
    public String getClassName(){
        return "TechnoTurboCompr";
    }
    public String getClassCode(){
        return "Compression";
    }

	//{{DECLARE_CONTROLS
	javax.swing.JTextField risentr_value = new javax.swing.JTextField();
	javax.swing.JTextField m_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabComprType = new javax.swing.JLabel();
	javax.swing.JTextField mc_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel14 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JTextField D_value = new javax.swing.JTextField();
	javax.swing.JTextField Kc_value = new javax.swing.JTextField();
	javax.swing.JTextField psiMax_value = new javax.swing.JTextField();
	javax.swing.JTextField psiCoeff_value = new javax.swing.JTextField();
	javax.swing.JTextField phiPsiMax_value = new javax.swing.JTextField();
	javax.swing.JTextField etaCoeff_value = new javax.swing.JTextField();
	javax.swing.JTextField etaMax_value = new javax.swing.JTextField();
	javax.swing.JTextField phiEtaMax_value = new javax.swing.JTextField();
	javax.swing.JTextField stageNumber_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel18 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JTextField N_value = new javax.swing.JTextField();
	//}}

	
	double getRisentr(){
	    return getRisentr(getFlow());
	}
	
	double getRisentr(double massFlow){
	    double reducedFlow=getComprReducedFlow(massFlow);
	    double etaCoeff=Util.lit_d(etaCoeff_value.getText());
	    double mc_max=Util.lit_d(phiEtaMax_value.getText());
	    Kc=Util.lit_d(Kc_value.getText());
	    double eta_max=Util.lit_d(etaMax_value.getText());
	    double eta=eta_max+etaCoeff*(reducedFlow-mc_max)*(reducedFlow-mc_max);
	    if(eta<eta_max-0.25)eta=eta_max-0.25;
	    return eta;
	}
	
	double getComprReducedFlow(double massFlowRate){
	    Kc=Util.lit_d(Kc_value.getText());
	    amont.getProperties();
        double reducedFlow=massFlowRate/amont.P*amont.T/Kc/N/100;
	    double Diam=1;//diamtre
	    double r=0.287;//Cp-Cv
	    return reducedFlow;
    }
    

	public void makeDesign(){
	    r_compr=aval.P/amont.P;
	    double r_isentr=getRisentr();
	    risentr_value.setText(Util.aff_d(r_isentr,4));
//	    display_value.setText(Util.aff_d(getLambdaVol(),4));
	    double val=getFlow();
	    m_value.setText(Util.aff_d(val,4));
	}

    
	public void readCompParameters(String ligne_data){
        D_value.setText(Util.extr_value(ligne_data, "D_value"));
        String valeur;
        valeur=Util.extr_value(ligne_data, "Kc_value");
        if(valeur!=null)Kc_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "psiMax_value");
        if(valeur!=null)psiMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "psiCoeff_value");
        if(valeur!=null)psiCoeff_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "phiPsiMax_value");
        if(valeur!=null)phiPsiMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "etaCoeff_value");
        if(valeur!=null)etaCoeff_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "etaMax_value");
        if(valeur!=null)etaMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "phiEtaMax_value");
        if(valeur!=null)phiEtaMax_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "N_value");
        if(valeur!=null)N_value.setText(valeur);
	}


	/**
	 * saves project file specific technoDesign data
	 */
    public String saveCompParameters(){
	    String h="D_value="+D_value.getText()+tab
	    +"Kc_value="+Kc_value.getText()+tab
	    +"psiMax_value="+psiMax_value.getText()+tab
	    +"psiCoeff_value="+psiCoeff_value.getText()+tab
	    +"phiPsiMax_value="+phiPsiMax_value.getText()+tab
	    +"etaCoeff_value="+etaCoeff_value.getText()+tab
	    +"etaMax_value="+etaMax_value.getText()+tab
	    +"phiEtaMax_value="+phiEtaMax_value.getText()+tab
	    +"N_value="+N_value.getText()+tab
	    +"\n";
        return h;
    }
}
 